/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20110211-32 [Feb 12 2011]
 * Copyright (c) 2000 - 2011 Intel Corporation
 * 
 * Disassembly of /Users/schneelowe/Downloads/DSDTFixer/DSDTFixer.app/Contents/Resources/files/DSDT.aml, Sun Oct  9 15:57:16 2011
 *
 * Original Table Header:
 *     Signature        "DSDT"
 *     Length           0x00005774 (22388)
 *     Revision         0x01 **** 32-bit table (V1), no 64-bit math support
 *     Checksum         0xCE
 *     OEM ID           "MEDION"
 *     OEM Table ID     "AWRDACPI"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20110211 (537985553)
 */

DefinitionBlock ("/Users/schneelowe/Downloads/DSDTFixer/DSDTFixer.app/Contents/Resources/files/DSDT.aml", "DSDT", 1, "MEDION", "AWRDACPI", 0x00001000)
{
    Method (DTGP, 5, NotSerialized)
    {
        If (LEqual (Arg0, Buffer (0x10)
                {
                    /* 0000 */    0xC6, 0xB7, 0xB5, 0xA0, 0x18, 0x13, 0x1C, 0x44, 
                    /* 0008 */    0xB0, 0xC9, 0xFE, 0x69, 0x5E, 0xAF, 0x94, 0x9B
                }))
        {
            If (LEqual (Arg1, One))
            {
                If (LEqual (Arg2, Zero))
                {
                    Store (Buffer (One)
                        {
                            0x03
                        }, Arg4)
                    Return (One)
                }

                If (LEqual (Arg2, One))
                {
                    Return (One)
                }
            }
        }

        Store (Buffer (One)
            {
                0x00
            }, Arg4)
        Return (Zero)
    }

    Scope (_PR)
    {
        Processor (CPU0, 0x00, 0x00000000, 0x00) {}
        Processor (CPU1, 0x01, 0x00000000, 0x00) {}
        Processor (CPU2, 0x02, 0x00000000, 0x00) {}
        Processor (CPU3, 0x03, 0x00000000, 0x00) {}
    }

    Name (_S0, Package (0x04)
    {
        Zero, 
        Zero, 
        Zero, 
        Zero
    })
    Name (SS1, Package (0x04)
    {
        0x04, 
        0x04, 
        0x04, 
        0x04
    })
    Name (_S3, Package (0x04)
    {
        One, 
        One, 
        One, 
        One
    })
    Name (_S4, Package (0x04)
    {
        0x02, 
        0x02, 
        0x02, 
        0x02
    })
    Name (_S5, Package (0x04)
    {
        0x02, 
        0x02, 
        0x02, 
        0x02
    })
    OperationRegion (DEBG, SystemIO, 0x80, One)
    Field (DEBG, ByteAcc, NoLock, Preserve)
    {
        DBG1,   8
    }

    OperationRegion (DEB2, SystemIO, 0x84, One)
    Field (DEB2, ByteAcc, NoLock, Preserve)
    {
        DBG2,   8
    }

    OperationRegion (DEB3, SystemIO, 0x88, One)
    Field (DEB3, ByteAcc, NoLock, Preserve)
    {
        DBG3,   8
    }

    OperationRegion (EXTM, SystemMemory, 0x000FF830, 0x10)
    Field (EXTM, WordAcc, NoLock, Preserve)
    {
        ROM1,   16, 
        RMS1,   16, 
        ROM2,   16, 
        RMS2,   16, 
        ROM3,   16, 
        RMS3,   16, 
        AMEM,   32
    }

    OperationRegion (GPST, SystemIO, 0x0420, 0x02)
    Field (GPST, ByteAcc, NoLock, Preserve)
    {
        GS00,   1, 
        GS01,   1, 
        GS02,   1, 
        GS03,   1, 
        GS04,   1, 
        GS05,   1, 
        GS06,   1, 
        GS07,   1, 
        GS08,   1, 
        GS09,   1, 
        GS10,   1, 
        GS11,   1, 
        GS12,   1, 
        GS13,   1, 
        GS14,   1, 
        GS15,   1
    }

    OperationRegion (ELCR, SystemIO, 0x04D0, 0x02)
    Field (ELCR, ByteAcc, NoLock, Preserve)
    {
        ELC1,   8, 
        ELC2,   8
    }

    OperationRegion (PMS, SystemIO, 0x0400, 0x02)
    Field (PMS, ByteAcc, NoLock, Preserve)
    {
        AITS,   1, 
                Offset (0x01), 
        PBTS,   1, 
            ,   6, 
        WAKE,   1
    }

    OperationRegion (GPSE, SystemIO, 0x0424, 0x02)
    Field (GPSE, ByteAcc, NoLock, Preserve)
    {
        GPS0,   1, 
        GPS1,   1, 
        KBCE,   1, 
        LANE,   1, 
        EXTE,   1, 
        PME,    1, 
                Offset (0x01), 
        RING,   1, 
            ,   5, 
        USBE,   1, 
                Offset (0x02)
    }

    OperationRegion (GLOS, SystemIO, 0x0428, 0x02)
    Field (GLOS, ByteAcc, NoLock, Preserve)
    {
            ,   6, 
        SSMI,   1, 
        PRII,   1, 
            ,   2, 
        SLPE,   1, 
        SIRS,   1, 
                Offset (0x02)
    }

    OperationRegion (WIRQ, SystemIO, 0x042A, One)
    Field (WIRQ, ByteAcc, NoLock, Preserve)
    {
        IRQR,   8
    }

    OperationRegion (GPNB, SystemIO, 0x042D, One)
    Field (GPNB, ByteAcc, NoLock, Preserve)
    {
            ,   5, 
        G89E,   1
    }

    OperationRegion (SMIC, SystemIO, 0x042F, One)
    Field (SMIC, ByteAcc, NoLock, Preserve)
    {
        SCP,    8
    }

    OperationRegion (STUS, SystemIO, 0x0430, One)
    Field (STUS, ByteAcc, NoLock, Preserve)
    {
            ,   1, 
        PADS,   7
    }

    OperationRegion (GPOB, SystemIO, 0x044C, 0x04)
    Field (GPOB, ByteAcc, NoLock, Preserve)
    {
        GP00,   1, 
        GP01,   1, 
        GP02,   1, 
        GP03,   1, 
        GP04,   1, 
        GP05,   1, 
        GP06,   1, 
        GP07,   1, 
        GP08,   1, 
        GP09,   1, 
        GP10,   1, 
        GP11,   1, 
        GP12,   1, 
        GP13,   1, 
        GP14,   1, 
        GP15,   1, 
        GP16,   1, 
        GP17,   1, 
        GP18,   1, 
        GP19,   1, 
        GP20,   1, 
        GP21,   1, 
        GP22,   1, 
        GP23,   1, 
        GP24,   1, 
        GP25,   1, 
        GP26,   1, 
        GP27,   1, 
        GP28,   1, 
        GP29,   1, 
        GP30,   1, 
        GPXX,   1
    }

    Name (OSFX, One)
    Name (OSFL, One)
    Method (STRC, 2, NotSerialized)
    {
        If (LNotEqual (SizeOf (Arg0), SizeOf (Arg1)))
        {
            Return (Zero)
        }

        Add (SizeOf (Arg0), One, Local0)
        Name (BUF0, Buffer (Local0) {})
        Name (BUF1, Buffer (Local0) {})
        Store (Arg0, BUF0)
        Store (Arg1, BUF1)
        While (Local0)
        {
            Decrement (Local0)
            If (LNotEqual (DerefOf (Index (BUF0, Local0)), DerefOf (Index (
                BUF1, Local0))))
            {
                Return (Zero)
            }
        }

        Return (One)
    }

    OperationRegion (RTCM, SystemIO, 0x70, 0x02)
    Field (RTCM, ByteAcc, NoLock, Preserve)
    {
        CMIN,   8, 
        CMDA,   8
    }

    IndexField (CMIN, CMDA, ByteAcc, NoLock, Preserve)
    {
                Offset (0x0F), 
        SHUT,   8
    }

    OperationRegion (INFO, SystemMemory, 0x000FF840, One)
    Field (INFO, ByteAcc, NoLock, Preserve)
    {
        KBDI,   1, 
        RTCW,   1, 
        PS2F,   1, 
        IRFL,   2, 
        DISE,   1, 
        SSHU,   1, 
        AWMD,   1
    }

    OperationRegion (BEEP, SystemIO, 0x61, One)
    Field (BEEP, ByteAcc, NoLock, Preserve)
    {
        S1B,    8
    }

    OperationRegion (CONT, SystemIO, 0x40, 0x04)
    Field (CONT, ByteAcc, NoLock, Preserve)
    {
        CNT0,   8, 
        CNT1,   8, 
        CNT2,   8, 
        CTRL,   8
    }

    Method (SPKR, 1, NotSerialized)
    {
        Store (S1B, Local0)
        Store (0xB6, CTRL)
        Store (0x55, CNT2)
        Store (0x03, CNT2)
        Store (Arg0, Local2)
        While (LGreater (Local2, Zero))
        {
            Or (S1B, 0x03, S1B)
            Store (0x5FFF, Local3)
            While (LGreater (Local3, Zero))
            {
                Decrement (Local3)
            }

            And (S1B, 0xFC, S1B)
            Store (0x0EFF, Local3)
            While (LGreater (Local3, Zero))
            {
                Decrement (Local3)
            }

            Decrement (Local2)
        }

        Store (Local0, S1B)
    }

    Scope (\)
    {
        Name (PICF, Zero)
        Method (_PIC, 1, NotSerialized)
        {
            Store (Arg0, PICF)
        }
    }

    Name (HPFL, Zero)
    Name (PMFL, Zero)
    Name (SBFL, Zero)
    Name (ATFL, Zero)
    Method (_PTS, 1, NotSerialized)
    {
        Or (Arg0, 0xF0, Local0)
        Store (Local0, DBG1)
        MDCS (Arg0)
        OSTP ()
        If (LEqual (Arg0, One))
        {
            While (PRII)
            {
                Store (One, PRII)
            }

            While (LNotEqual (PADS, Zero))
            {
                Store (PADS, PADS)
            }

            Or (IRQR, 0x80, IRQR)
        }

        If (LEqual (Arg0, 0x03))
        {
            Store (0x4D, SCP)
        }

        If (LEqual (Arg0, 0x04))
        {
            Store (One, LANE)
        }

        If (LEqual (Arg0, 0x05))
        {
            Store (Zero, GS04)
            Store (One, LANE)
        }

        Sleep (0x64)
        If (LEqual (Arg0, One)) {}
        If (LEqual (Arg0, 0x03)) {}
        If (LEqual (Arg0, 0x04)) {}
        If (LEqual (Arg0, 0x05)) {}
    }

    Method (_WAK, 1, NotSerialized)
    {
        Store (0xFF, DBG1)
        If (LEqual (Arg0, 0x03))
        {
            MDCS (Zero)
        }

        If (LEqual (Arg0, One)) {}
        If (LEqual (Arg0, One))
        {
            And (IRQR, 0x7F, IRQR)
            While (PRII)
            {
                Store (One, PRII)
            }

            While (LNotEqual (PADS, Zero))
            {
                Store (PADS, PADS)
            }
        }

        If (OSFL)
        {
            Notify (\_SB.PWRB, 0x02)
            Notify (\_SB.SLPB, 0x02)
        }
        Else
        {
            If (LEqual (RTCW, Zero))
            {
                Notify (\_SB.PWRB, 0x02)
                Notify (\_SB.SLPB, 0x02)
            }
        }

        Return (Package (0x02)
        {
            Zero, 
            Zero
        })
    }

    Scope (_SI)
    {
        Method (_MSG, 1, NotSerialized)
        {
            Store ("Local0", Local0)
        }

        Method (_SST, 1, NotSerialized)
        {
            Store ("Local0", Local0)
        }
    }

    Scope (_GPE)
    {
        Method (_L03, 0, NotSerialized)
        {
            Notify (\_SB.PCI0.LAN1, 0x02)
        }

        Method (_L04, 0, NotSerialized)
        {
            Notify (\_SB.SLPB, 0x80)
        }

        Method (_L05, 0, NotSerialized)
        {
            Notify (\_SB.PCI0, 0x02)
            Notify (\_SB.PCI0.P2PB, 0x02)
        }

        Method (_L08, 0, NotSerialized)
        {
            Notify (\_SB.PCI0.UAR1, 0x02)
        }

        Method (_L0D, 0, NotSerialized)
        {
            Notify (\_SB.PCI0.P2PE.AZAC, 0x02)
        }

        Method (_L0E, 0, NotSerialized)
        {
            Notify (\_SB.PCI0.USB1, 0x02)
            Notify (\_SB.PCI0.USB2, 0x02)
            Notify (\_SB.PCI0.USB3, 0x02)
            Notify (\_SB.PCI0.USB4, 0x02)
            Notify (\_SB.PCI0.EHCI, 0x02)
        }

        Method (_L12, 0, NotSerialized)
        {
            If (LEqual (PMFL, Zero))
            {
                Notify (\_SB.PCI0.PEXG, 0x02)
                Notify (\_SB.PCI0.PEX0, 0x02)
                Notify (\_SB.PCI0.PEX1, 0x02)
                Notify (\_SB.PCI0.PEX2, 0x02)
                Notify (\_SB.PCI0.PEX3, 0x02)
                Notify (\_SB.PCI0.P2PE.PE5C, 0x02)
                Notify (\_SB.PCI0.P2PE.PE6C, 0x02)
            }
        }

        Method (_L13, 0, NotSerialized)
        {
            If (LEqual (HPFL, Zero))
            {
                Notify (\_SB.PCI0.PEXG.S0F0, One)
                Notify (\_SB.PCI0.PEXG.S0F1, One)
                Notify (\_SB.PCI0.PEXG.S0F2, One)
                Notify (\_SB.PCI0.PEXG.S0F3, One)
                Notify (\_SB.PCI0.PEXG.S0F4, One)
                Notify (\_SB.PCI0.PEXG.S0F5, One)
                Notify (\_SB.PCI0.PEXG.S0F6, One)
                Notify (\_SB.PCI0.PEXG.S0F7, One)
                Notify (\_SB.PCI0.PEX0.S1F0, One)
                Notify (\_SB.PCI0.PEX0.S1F1, One)
                Notify (\_SB.PCI0.PEX0.S1F2, One)
                Notify (\_SB.PCI0.PEX0.S1F3, One)
                Notify (\_SB.PCI0.PEX0.S1F4, One)
                Notify (\_SB.PCI0.PEX0.S1F5, One)
                Notify (\_SB.PCI0.PEX0.S1F6, One)
                Notify (\_SB.PCI0.PEX0.S1F7, One)
                Notify (\_SB.PCI0.PEX1.S2F0, One)
                Notify (\_SB.PCI0.PEX1.S2F1, One)
                Notify (\_SB.PCI0.PEX1.S2F2, One)
                Notify (\_SB.PCI0.PEX1.S2F3, One)
                Notify (\_SB.PCI0.PEX1.S2F4, One)
                Notify (\_SB.PCI0.PEX1.S2F5, One)
                Notify (\_SB.PCI0.PEX1.S2F6, One)
                Notify (\_SB.PCI0.PEX1.S2F7, One)
                Notify (\_SB.PCI0.PEX2.S3F0, One)
                Notify (\_SB.PCI0.PEX2.S3F1, One)
                Notify (\_SB.PCI0.PEX2.S3F2, One)
                Notify (\_SB.PCI0.PEX2.S3F3, One)
                Notify (\_SB.PCI0.PEX2.S3F4, One)
                Notify (\_SB.PCI0.PEX2.S3F5, One)
                Notify (\_SB.PCI0.PEX2.S3F6, One)
                Notify (\_SB.PCI0.PEX2.S3F7, One)
                Notify (\_SB.PCI0.PEX3.S4F0, One)
                Notify (\_SB.PCI0.PEX3.S4F1, One)
                Notify (\_SB.PCI0.PEX3.S4F2, One)
                Notify (\_SB.PCI0.PEX3.S4F3, One)
                Notify (\_SB.PCI0.PEX3.S4F4, One)
                Notify (\_SB.PCI0.PEX3.S4F5, One)
                Notify (\_SB.PCI0.PEX3.S4F6, One)
                Notify (\_SB.PCI0.PEX3.S4F7, One)
                Notify (\_SB.PCI0.P2PE.PE5C.S5F0, One)
                Notify (\_SB.PCI0.P2PE.PE5C.S5F1, One)
                Notify (\_SB.PCI0.P2PE.PE5C.S5F2, One)
                Notify (\_SB.PCI0.P2PE.PE5C.S5F3, One)
                Notify (\_SB.PCI0.P2PE.PE5C.S5F4, One)
                Notify (\_SB.PCI0.P2PE.PE5C.S5F5, One)
                Notify (\_SB.PCI0.P2PE.PE5C.S5F6, One)
                Notify (\_SB.PCI0.P2PE.PE5C.S5F7, One)
                Notify (\_SB.PCI0.P2PE.PE6C.S6F0, One)
                Notify (\_SB.PCI0.P2PE.PE6C.S6F1, One)
                Notify (\_SB.PCI0.P2PE.PE6C.S6F2, One)
                Notify (\_SB.PCI0.P2PE.PE6C.S6F3, One)
                Notify (\_SB.PCI0.P2PE.PE6C.S6F4, One)
                Notify (\_SB.PCI0.P2PE.PE6C.S6F5, One)
                Notify (\_SB.PCI0.P2PE.PE6C.S6F6, One)
                Notify (\_SB.PCI0.P2PE.PE6C.S6F7, One)
            }
        }
    }

    Scope (_SB)
    {
        Device (PWRB)
        {
            Name (_HID, EisaId ("PNP0C0C"))
            Method (_STA, 0, NotSerialized)
            {
                Return (0x0B)
            }
        }

        Device (SLPB)
        {
            Name (_HID, EisaId ("PNP0C0E"))
            Method (_STA, 0, NotSerialized)
            {
                Return (0x0B)
            }

            Name (_PRW, Package (0x02)
            {
                0x04, 
                0x05
            })
        }

        Device (PCI0)
        {
            Name (_HID, EisaId ("PNP0A08"))
            Name (_CID, EisaId ("PNP0A03"))
            Name (_ADR, Zero)
            Name (_UID, One)
            Name (_BBN, Zero)
            Method (_S3D, 0, NotSerialized)
            {
                If (LEqual (OSFL, 0x02))
                {
                    Return (0x02)
                }
                Else
                {
                    Return (0x03)
                }
            }

            OperationRegion (GART, PCI_Config, 0x80, One)
            Scope (\)
            {
                Field (\_SB.PCI0.GART, ByteAcc, NoLock, Preserve)
                {
                    GAR1,   8
                }
            }

            OperationRegion (GARA, PCI_Config, 0x88, One)
            Scope (\)
            {
                Field (\_SB.PCI0.GARA, ByteAcc, NoLock, Preserve)
                {
                    GAR2,   8
                }
            }

            Method (_STA, 0, NotSerialized)
            {
                Return (0x0F)
            }

            Name (_PRW, Package (0x02)
            {
                0x05, 
                0x05
            })
            Method (_CRS, 0, NotSerialized)
            {
                Name (BUF0, ResourceTemplate ()
                {
                    WordBusNumber (ResourceConsumer, MinNotFixed, MaxNotFixed, PosDecode,
                        0x0000,             // Granularity
                        0x0000,             // Range Minimum
                        0x00FF,             // Range Maximum
                        0x0000,             // Translation Offset
                        0x0100,             // Length
                        ,, )
                    IO (Decode16,
                        0x0CF8,             // Range Minimum
                        0x0CF8,             // Range Maximum
                        0x01,               // Alignment
                        0x08,               // Length
                        )
                    WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                        0x0000,             // Granularity
                        0x0000,             // Range Minimum
                        0x0CF7,             // Range Maximum
                        0x0000,             // Translation Offset
                        0x0CF8,             // Length
                        ,, , TypeStatic)
                    WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                        0x0000,             // Granularity
                        0x0D00,             // Range Minimum
                        0xFFFF,             // Range Maximum
                        0x0000,             // Translation Offset
                        0xF300,             // Length
                        ,, , TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000A0000,         // Range Minimum
                        0x000BFFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00020000,         // Length
                        ,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000C0000,         // Range Minimum
                        0x000DFFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00020000,         // Length
                        ,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0xFEBFFFFE,         // Range Minimum
                        0xFEBFFFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00000002,         // Length
                        ,, _Y00, AddressRangeMemory, TypeStatic)
                })
                CreateDWordField (BUF0, \_SB.PCI0._CRS._Y00._MIN, TCMM)
                CreateDWordField (BUF0, \_SB.PCI0._CRS._Y00._LEN, TOMM)
                Add (AMEM, 0x00010000, TCMM)
                Add (TCMM, 0x00010000, TCMM)
                Subtract (0xFEC00000, TCMM, TOMM)
                Return (BUF0)
            }

            Name (PICM, Package (0x28)
            {
                Package (0x04)
                {
                    0x0008FFFF, 
                    Zero, 
                    LNKA, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0008FFFF, 
                    One, 
                    LNKB, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0008FFFF, 
                    0x02, 
                    LNKC, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0008FFFF, 
                    0x03, 
                    LNKD, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0009FFFF, 
                    Zero, 
                    LNKB, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0009FFFF, 
                    One, 
                    LNKC, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0009FFFF, 
                    0x02, 
                    LNKD, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0009FFFF, 
                    0x03, 
                    LNKA, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x000AFFFF, 
                    Zero, 
                    LNKC, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x000AFFFF, 
                    One, 
                    LNKD, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x000AFFFF, 
                    0x02, 
                    LNKA, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x000AFFFF, 
                    0x03, 
                    LNKB, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0001FFFF, 
                    Zero, 
                    LNKA, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0001FFFF, 
                    One, 
                    LNKB, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0001FFFF, 
                    0x02, 
                    LNKC, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0001FFFF, 
                    0x03, 
                    LNKD, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0002FFFF, 
                    Zero, 
                    LNK1, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0002FFFF, 
                    One, 
                    LNK1, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0002FFFF, 
                    0x02, 
                    LNK1, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0002FFFF, 
                    0x03, 
                    LNK1, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0003FFFF, 
                    Zero, 
                    LNK1, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0003FFFF, 
                    One, 
                    LNK1, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0003FFFF, 
                    0x02, 
                    LNK1, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0003FFFF, 
                    0x03, 
                    LNK1, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x000FFFFF, 
                    Zero, 
                    LNKA, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x000FFFFF, 
                    One, 
                    LNKB, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x000FFFFF, 
                    0x02, 
                    LNKC, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x000FFFFF, 
                    0x03, 
                    LNKD, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0010FFFF, 
                    Zero, 
                    LNKA, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0010FFFF, 
                    One, 
                    LNKB, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0010FFFF, 
                    0x02, 
                    LNKC, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0010FFFF, 
                    0x03, 
                    LNKD, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0011FFFF, 
                    Zero, 
                    LNKA, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0011FFFF, 
                    One, 
                    LNKB, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0011FFFF, 
                    0x02, 
                    LNKC, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0011FFFF, 
                    0x03, 
                    LNKD, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0012FFFF, 
                    Zero, 
                    LNKA, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0012FFFF, 
                    One, 
                    LNKB, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0012FFFF, 
                    0x02, 
                    LNKC, 
                    Zero
                }, 

                Package (0x04)
                {
                    0x0012FFFF, 
                    0x03, 
                    LNKD, 
                    Zero
                }
            })
            Name (APIC, Package (0x28)
            {
                Package (0x04)
                {
                    0x0008FFFF, 
                    Zero, 
                    Zero, 
                    0x10
                }, 

                Package (0x04)
                {
                    0x0008FFFF, 
                    One, 
                    Zero, 
                    0x11
                }, 

                Package (0x04)
                {
                    0x0008FFFF, 
                    0x02, 
                    Zero, 
                    0x12
                }, 

                Package (0x04)
                {
                    0x0008FFFF, 
                    0x03, 
                    Zero, 
                    0x13
                }, 

                Package (0x04)
                {
                    0x0009FFFF, 
                    Zero, 
                    Zero, 
                    0x11
                }, 

                Package (0x04)
                {
                    0x0009FFFF, 
                    One, 
                    Zero, 
                    0x12
                }, 

                Package (0x04)
                {
                    0x0009FFFF, 
                    0x02, 
                    Zero, 
                    0x13
                }, 

                Package (0x04)
                {
                    0x0009FFFF, 
                    0x03, 
                    Zero, 
                    0x10
                }, 

                Package (0x04)
                {
                    0x000AFFFF, 
                    Zero, 
                    Zero, 
                    0x12
                }, 

                Package (0x04)
                {
                    0x000AFFFF, 
                    One, 
                    Zero, 
                    0x13
                }, 

                Package (0x04)
                {
                    0x000AFFFF, 
                    0x02, 
                    Zero, 
                    0x10
                }, 

                Package (0x04)
                {
                    0x000AFFFF, 
                    0x03, 
                    Zero, 
                    0x11
                }, 

                Package (0x04)
                {
                    0x0001FFFF, 
                    Zero, 
                    Zero, 
                    0x10
                }, 

                Package (0x04)
                {
                    0x0001FFFF, 
                    One, 
                    Zero, 
                    0x11
                }, 

                Package (0x04)
                {
                    0x0001FFFF, 
                    0x02, 
                    Zero, 
                    0x12
                }, 

                Package (0x04)
                {
                    0x0001FFFF, 
                    0x03, 
                    Zero, 
                    0x13
                }, 

                Package (0x04)
                {
                    0x0002FFFF, 
                    Zero, 
                    Zero, 
                    0x1B
                }, 

                Package (0x04)
                {
                    0x0002FFFF, 
                    One, 
                    Zero, 
                    0x1B
                }, 

                Package (0x04)
                {
                    0x0002FFFF, 
                    0x02, 
                    Zero, 
                    0x1B
                }, 

                Package (0x04)
                {
                    0x0002FFFF, 
                    0x03, 
                    Zero, 
                    0x1B
                }, 

                Package (0x04)
                {
                    0x0003FFFF, 
                    Zero, 
                    Zero, 
                    0x1F
                }, 

                Package (0x04)
                {
                    0x0003FFFF, 
                    One, 
                    Zero, 
                    0x23
                }, 

                Package (0x04)
                {
                    0x0003FFFF, 
                    0x02, 
                    Zero, 
                    0x27
                }, 

                Package (0x04)
                {
                    0x0003FFFF, 
                    0x03, 
                    Zero, 
                    0x2B
                }, 

                Package (0x04)
                {
                    0x000FFFFF, 
                    Zero, 
                    Zero, 
                    0x14
                }, 

                Package (0x04)
                {
                    0x000FFFFF, 
                    One, 
                    Zero, 
                    0x15
                }, 

                Package (0x04)
                {
                    0x000FFFFF, 
                    0x02, 
                    Zero, 
                    0x16
                }, 

                Package (0x04)
                {
                    0x000FFFFF, 
                    0x03, 
                    Zero, 
                    0x17
                }, 

                Package (0x04)
                {
                    0x0010FFFF, 
                    Zero, 
                    Zero, 
                    0x14
                }, 

                Package (0x04)
                {
                    0x0010FFFF, 
                    One, 
                    Zero, 
                    0x15
                }, 

                Package (0x04)
                {
                    0x0010FFFF, 
                    0x02, 
                    Zero, 
                    0x16
                }, 

                Package (0x04)
                {
                    0x0010FFFF, 
                    0x03, 
                    Zero, 
                    0x17
                }, 

                Package (0x04)
                {
                    0x0011FFFF, 
                    Zero, 
                    Zero, 
                    0x14
                }, 

                Package (0x04)
                {
                    0x0011FFFF, 
                    One, 
                    Zero, 
                    0x15
                }, 

                Package (0x04)
                {
                    0x0011FFFF, 
                    0x02, 
                    Zero, 
                    0x16
                }, 

                Package (0x04)
                {
                    0x0011FFFF, 
                    0x03, 
                    Zero, 
                    0x17
                }, 

                Package (0x04)
                {
                    0x0012FFFF, 
                    Zero, 
                    Zero, 
                    0x17
                }, 

                Package (0x04)
                {
                    0x0012FFFF, 
                    One, 
                    Zero, 
                    0x17
                }, 

                Package (0x04)
                {
                    0x0012FFFF, 
                    0x02, 
                    Zero, 
                    0x17
                }, 

                Package (0x04)
                {
                    0x0012FFFF, 
                    0x03, 
                    Zero, 
                    0x17
                }
            })
            Method (_PRT, 0, NotSerialized)
            {
                If (LNot (PICF))
                {
                    Return (PICM)
                }
                Else
                {
                    Return (APIC)
                }
            }

            Device (PMIO)
            {
                Name (_HID, EisaId ("PNP0C02"))
                Name (_UID, 0x02)
                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUF0, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0400,             // Range Minimum
                            0x0400,             // Range Maximum
                            0x01,               // Alignment
                            0x80,               // Length
                            )
                        IO (Decode16,
                            0x0500,             // Range Minimum
                            0x0500,             // Range Maximum
                            0x01,               // Alignment
                            0x10,               // Length
                            )
                    })
                    Return (BUF0)
                }
            }

            Device (NBF4)
            {
                Name (_ADR, 0x04)
                OperationRegion (IRID, PCI_Config, 0xF6, One)
                Field (IRID, ByteAcc, NoLock, Preserve)
                {
                    REBD,   8
                }
            }

            Device (VT86)
            {
                Name (_ADR, 0x00110000)
                OperationRegion (USBC, PCI_Config, 0x50, 0x02)
                Scope (\)
                {
                    Field (\_SB.PCI0.VT86.USBC, ByteAcc, NoLock, Preserve)
                    {
                        IDEB,   8
                    }
                }

                OperationRegion (LPIO, PCI_Config, 0x6E, One)
                Scope (\)
                {
                    Field (\_SB.PCI0.VT86.LPIO, ByteAcc, NoLock, Preserve)
                    {
                        LPE1,   8
                    }
                }

                OperationRegion (VTSB, PCI_Config, Zero, 0x0100)
                Scope (\)
                {
                    Field (\_SB.PCI0.VT86.VTSB, ByteAcc, NoLock, Preserve)
                    {
                                Offset (0x02), 
                        DEID,   16, 
                                Offset (0x2C), 
                        ID2C,   8, 
                        ID2D,   8, 
                        ID2E,   8, 
                        ID2F,   8, 
                                Offset (0x44), 
                        PIRE,   4, 
                        PIRF,   4, 
                        PIRG,   4, 
                        PIRH,   4, 
                        POLE,   1, 
                        POLF,   1, 
                        POLG,   1, 
                        POLH,   1, 
                        ENR8,   1, 
                                Offset (0x50), 
                        ESB4,   1, 
                        ESB3,   1, 
                        ESB2,   1, 
                        EIDE,   1, 
                        EUSB,   1, 
                        ESB1,   1, 
                        EAMC,   2, 
                        EKBC,   1, 
                        KBCC,   1, 
                        EPS2,   1, 
                        ERTC,   1, 
                        ELAN,   1, 
                            ,   2, 
                        USBD,   1, 
                        SIRQ,   8, 
                                Offset (0x55), 
                        PIRA,   8, 
                        PIBC,   8, 
                        PIRD,   8, 
                                Offset (0x68), 
                            ,   7, 
                        HPTF,   1, 
                                Offset (0x7B), 
                            ,   6, 
                        BSAT,   1, 
                                Offset (0x94), 
                        PWC1,   2, 
                        GPO1,   1, 
                        GPO2,   1, 
                        GPO3,   1, 
                        PLLD,   1, 
                                Offset (0xEC), 
                        ENWT,   3
                    }
                }

                OperationRegion (SBPR, PCI_Config, Zero, 0xE8)
                Field (SBPR, ByteAcc, NoLock, Preserve)
                {
                            Offset (0xE2), 
                        ,   1, 
                    SBPM,   1, 
                    SBHP,   1
                }

                Scope (\)
                {
                    Method (DISD, 1, NotSerialized)
                    {
                        Store ("Local0", Local0)
                    }

                    Method (CKIO, 2, NotSerialized)
                    {
                        Store ("Local0", Local0)
                    }

                    Method (SLDM, 2, NotSerialized)
                    {
                        Store ("Local0", Local0)
                    }
                }
            }

            Device (SATA)
            {
                Method (_ADR, 0, NotSerialized)
                {
                    If (LEqual (ATFL, 0x02))
                    {
                        Return (0x000F0001)
                    }
                    Else
                    {
                        Return (0x000F0000)
                    }
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        If (LEqual (CMDR, Zero))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }
                }

                OperationRegion (SAPR, PCI_Config, Zero, 0xC2)
                Field (SAPR, ByteAcc, NoLock, Preserve)
                {
                    VID,    16, 
                            Offset (0x04), 
                    CMDR,   3, 
                            Offset (0x3C), 
                    IDEI,   8, 
                            Offset (0x49), 
                        ,   6, 
                    EPHY,   1
                }

                Name (REGF, One)
                Method (_REG, 2, NotSerialized)
                {
                    If (LEqual (Arg0, 0x02))
                    {
                        Store (Arg1, REGF)
                    }
                }

                Name (TIM0, Package (0x04)
                {
                    Package (0x05)
                    {
                        0x78, 
                        0xB4, 
                        0xF0, 
                        0x017F, 
                        0x0258
                    }, 

                    Package (0x05)
                    {
                        0x20, 
                        0x22, 
                        0x33, 
                        0x47, 
                        0x5D
                    }, 

                    Package (0x07)
                    {
                        0x78, 
                        0x50, 
                        0x3C, 
                        0x2D, 
                        0x1E, 
                        0x14, 
                        0x0F
                    }, 

                    Package (0x0F)
                    {
                        0x06, 
                        0x05, 
                        0x04, 
                        0x04, 
                        0x03, 
                        0x03, 
                        0x02, 
                        0x02, 
                        One, 
                        One, 
                        One, 
                        One, 
                        One, 
                        One, 
                        Zero
                    }
                })
                Name (TMD0, Buffer (0x14) {})
                CreateDWordField (TMD0, Zero, PIO0)
                CreateDWordField (TMD0, 0x04, DMA0)
                CreateDWordField (TMD0, 0x08, PIO1)
                CreateDWordField (TMD0, 0x0C, DMA1)
                CreateDWordField (TMD0, 0x10, CHNF)
                Name (PMPT, 0x20)
                Name (PMUE, 0x07)
                Name (PMUT, Zero)
                Name (PSPT, 0x20)
                Name (PSUE, 0x07)
                Name (PSUT, Zero)
                Name (SMPT, 0x20)
                Name (SMUE, 0x07)
                Name (SMUT, Zero)
                Name (SSPT, 0x20)
                Name (SSUE, 0x07)
                Name (SSUT, Zero)
                Device (CHN0)
                {
                    Name (_ADR, Zero)
                    Method (_STA, 0, NotSerialized)
                    {
                        Return (0x0F)
                    }

                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (GTM (PMPT, PMUE, PMUT, PSPT, PSUE, PSUT))
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                    }

                    Device (DRV0)
                    {
                        Name (_ADR, Zero)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Concatenate (Buffer (0x07)
                                {
                                    0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
                                }, Buffer (0x07)
                                {
                                    0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
                                }, Local5)
                            Return (Local5)
                        }
                    }

                    Device (DRV1)
                    {
                        Name (_ADR, One)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Concatenate (Buffer (0x07)
                                {
                                    0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
                                }, Buffer (0x07)
                                {
                                    0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
                                }, Local5)
                            Return (Local5)
                        }
                    }
                }

                Device (CHN1)
                {
                    Name (_ADR, One)
                    Method (_STA, 0, NotSerialized)
                    {
                        Return (0x0F)
                    }

                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (GTM (SMPT, SMUE, SMUT, SSPT, SSUE, SSUT))
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                    }

                    Device (DRV0)
                    {
                        Name (_ADR, Zero)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Concatenate (Buffer (0x07)
                                {
                                    0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
                                }, Buffer (0x07)
                                {
                                    0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
                                }, Local5)
                            Return (Local5)
                        }
                    }

                    Device (DRV1)
                    {
                        Name (_ADR, One)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Concatenate (Buffer (0x07)
                                {
                                    0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
                                }, Buffer (0x07)
                                {
                                    0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
                                }, Local5)
                            Return (Local5)
                        }
                    }
                }

                Method (GTM, 6, Serialized)
                {
                    Store (Ones, PIO0)
                    Store (Ones, PIO1)
                    Store (Ones, DMA0)
                    Store (Ones, DMA1)
                    Store (0x10, CHNF)
                    If (REGF) {}
                    Else
                    {
                        Return (TMD0)
                    }

                    Store (Match (DerefOf (Index (TIM0, One)), MEQ, Arg0, MTR, 
                        Zero, Zero), Local6)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, Zero)), Local6)), 
                        Local7)
                    Store (Local7, DMA0)
                    Store (Local7, PIO0)
                    Store (Match (DerefOf (Index (TIM0, One)), MEQ, Arg3, MTR, 
                        Zero, Zero), Local6)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, Zero)), Local6)), 
                        Local7)
                    Store (Local7, DMA1)
                    Store (Local7, PIO1)
                    If (Arg1)
                    {
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x03)), Arg2)), 
                            Local5)
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x02)), Local5)), 
                            DMA0)
                        Or (CHNF, One, CHNF)
                    }

                    If (Arg4)
                    {
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x03)), Arg5)), 
                            Local5)
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x02)), Local5)), 
                            DMA1)
                        Or (CHNF, 0x04, CHNF)
                    }

                    Return (TMD0)
                }
            }

            Device (PATA)
            {
                Method (_ADR, 0, NotSerialized)
                {
                    If (LEqual (ATFL, 0x02))
                    {
                        Return (0x000F0000)
                    }
                    Else
                    {
                        Return (0x000F0001)
                    }
                }

                Name (REGF, One)
                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        PMEX ()
                        If (LEqual (CMDR, Zero))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }
                }

                Method (_REG, 2, NotSerialized)
                {
                    If (LEqual (Arg0, 0x02))
                    {
                        Store (Arg1, REGF)
                    }
                }

                Name (TIM0, Package (0x07)
                {
                    Package (0x05)
                    {
                        0x78, 
                        0xB4, 
                        0xF0, 
                        0x017F, 
                        0x0258
                    }, 

                    Package (0x05)
                    {
                        0x20, 
                        0x22, 
                        0x33, 
                        0x47, 
                        0x5D
                    }, 

                    Package (0x05)
                    {
                        0x04, 
                        0x03, 
                        0x02, 
                        One, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x02, 
                        One, 
                        Zero, 
                        Zero
                    }, 

                    Package (0x07)
                    {
                        0x78, 
                        0x50, 
                        0x3C, 
                        0x2D, 
                        0x1E, 
                        0x14, 
                        0x0F
                    }, 

                    Package (0x0F)
                    {
                        0x06, 
                        0x05, 
                        0x04, 
                        0x04, 
                        0x03, 
                        0x03, 
                        0x02, 
                        0x02, 
                        One, 
                        One, 
                        One, 
                        One, 
                        One, 
                        One, 
                        Zero
                    }, 

                    Package (0x07)
                    {
                        0x0E, 
                        0x08, 
                        0x06, 
                        0x04, 
                        0x02, 
                        One, 
                        Zero
                    }
                })
                Name (TMD0, Buffer (0x14) {})
                CreateDWordField (TMD0, Zero, PIO0)
                CreateDWordField (TMD0, 0x04, DMA0)
                CreateDWordField (TMD0, 0x08, PIO1)
                CreateDWordField (TMD0, 0x0C, DMA1)
                CreateDWordField (TMD0, 0x10, CHNF)
                OperationRegion (PAPR, PCI_Config, Zero, 0xC2)
                Field (PAPR, ByteAcc, NoLock, Preserve)
                {
                    VID,    16, 
                            Offset (0x04), 
                    CMDR,   3, 
                            Offset (0x09), 
                    ENAT,   4, 
                            Offset (0x3C), 
                    IDEI,   8, 
                            Offset (0x40), 
                    ESCH,   1, 
                    EPCH,   1, 
                            Offset (0x48), 
                    SSPT,   8, 
                    SMPT,   8, 
                    PSPT,   8, 
                    PMPT,   8, 
                            Offset (0x50), 
                    SSUT,   4, 
                    SSCT,   1, 
                    SSUE,   3, 
                    SMUT,   4, 
                    SMCT,   1, 
                    SMUE,   3, 
                    PSUT,   4, 
                    PSCT,   1, 
                    PSUE,   3, 
                    PMUT,   4, 
                    PMCT,   1, 
                    PMUE,   3
                }

                Name (GMPT, Zero)
                Name (GMUE, Zero)
                Name (GMUT, Zero)
                Name (GSPT, Zero)
                Name (GSUE, Zero)
                Name (GSUT, Zero)
                Device (CHN0)
                {
                    Name (_ADR, Zero)
                    Method (_STA, 0, NotSerialized)
                    {
                        If (LNotEqual (EPCH, One))
                        {
                            Return (Zero)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }

                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (GTM (PMPT, PMUE, PMUT, PSPT, PSUE, PSUT))
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, TMD0)
                        Store (PMPT, GMPT)
                        Store (PMUE, GMUE)
                        Store (PMUT, GMUT)
                        Store (PSPT, GSPT)
                        Store (PSUE, GSUE)
                        Store (PSUT, GSUT)
                        STM ()
                        Store (GMPT, PMPT)
                        Store (GMUE, PMUE)
                        Store (GMUT, PMUT)
                        Store (GSPT, PSPT)
                        Store (GSUE, PSUE)
                        Store (GSUT, PSUT)
                    }

                    Device (DRV0)
                    {
                        Name (_ADR, Zero)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (GTF (Zero, PMUE, PMUT, PMPT))
                        }
                    }

                    Device (DRV1)
                    {
                        Name (_ADR, One)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (GTF (One, PSUE, PSUT, PSPT))
                        }
                    }
                }

                Device (CHN1)
                {
                    Name (_ADR, One)
                    Method (_STA, 0, NotSerialized)
                    {
                        If (LNotEqual (ESCH, One))
                        {
                            Return (Zero)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }

                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (GTM (SMPT, SMUE, SMUT, SSPT, SSUE, SSUT))
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, TMD0)
                        Store (SMPT, GMPT)
                        Store (SMUE, GMUE)
                        Store (SMUT, GMUT)
                        Store (SSPT, GSPT)
                        Store (SSUE, GSUE)
                        Store (SSUT, GSUT)
                        STM ()
                        Store (GMPT, SMPT)
                        Store (GMUE, SMUE)
                        Store (GMUT, SMUT)
                        Store (GSPT, SSPT)
                        Store (GSUE, SSUE)
                        Store (GSUT, SSUT)
                    }

                    Device (DRV0)
                    {
                        Name (_ADR, Zero)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (GTF (0x02, SMUE, SMUT, SMPT))
                        }
                    }

                    Device (DRV1)
                    {
                        Name (_ADR, One)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (GTF (0x03, SSUE, SSUT, SSPT))
                        }
                    }
                }

                Method (PMEX, 0, Serialized)
                {
                    If (REGF)
                    {
                        If (LEqual (PMPT, 0xA8))
                        {
                            Store (0x5D, PMPT)
                        }

                        If (LEqual (PMPT, 0x65))
                        {
                            Store (0x33, PMPT)
                        }

                        If (LEqual (PMPT, 0x31))
                        {
                            Store (0x22, PMPT)
                        }

                        If (LEqual (PSPT, 0xA8))
                        {
                            Store (0x5D, PSPT)
                        }

                        If (LEqual (PSPT, 0x65))
                        {
                            Store (0x33, PSPT)
                        }

                        If (LEqual (PSPT, 0x31))
                        {
                            Store (0x22, PSPT)
                        }

                        If (LEqual (SMPT, 0xA8))
                        {
                            Store (0x5D, SMPT)
                        }

                        If (LEqual (SMPT, 0x65))
                        {
                            Store (0x33, SMPT)
                        }

                        If (LEqual (SMPT, 0x31))
                        {
                            Store (0x22, SMPT)
                        }

                        If (LEqual (SSPT, 0xA8))
                        {
                            Store (0x5D, SSPT)
                        }

                        If (LEqual (SSPT, 0x65))
                        {
                            Store (0x33, SSPT)
                        }

                        If (LEqual (SSPT, 0x31))
                        {
                            Store (0x22, SSPT)
                        }
                    }
                }

                Method (GTF, 4, Serialized)
                {
                    Store (Buffer (0x07)
                        {
                            0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                        }, Local1)
                    Store (Buffer (0x07)
                        {
                            0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                        }, Local2)
                    CreateByteField (Local1, One, MODE)
                    CreateByteField (Local2, One, UMOD)
                    CreateByteField (Local1, 0x05, PCHA)
                    CreateByteField (Local2, 0x05, UCHA)
                    And (Arg0, 0x03, Local3)
                    If (LEqual (And (Local3, One), One))
                    {
                        Store (0xB0, PCHA)
                        Store (0xB0, UCHA)
                    }

                    If (Arg1)
                    {
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x05)), Arg2)), 
                            UMOD)
                        Or (UMOD, 0x40, UMOD)
                    }
                    Else
                    {
                        Store (Match (DerefOf (Index (TIM0, One)), MEQ, Arg3, MTR, 
                            Zero, Zero), Local0)
                        Or (0x20, DerefOf (Index (DerefOf (Index (TIM0, 0x03)), Local0
                            )), UMOD)
                    }

                    Store (Match (DerefOf (Index (TIM0, One)), MEQ, Arg3, MTR, 
                        Zero, Zero), Local0)
                    Or (0x08, DerefOf (Index (DerefOf (Index (TIM0, 0x02)), Local0
                        )), MODE)
                    Concatenate (Local1, Local2, Local6)
                    Return (Local6)
                }

                Method (GTM, 6, Serialized)
                {
                    Store (Ones, PIO0)
                    Store (Ones, PIO1)
                    Store (Ones, DMA0)
                    Store (Ones, DMA1)
                    Store (0x10, CHNF)
                    If (REGF) {}
                    Else
                    {
                        Return (TMD0)
                    }

                    Store (Match (DerefOf (Index (TIM0, One)), MEQ, Arg0, MTR, 
                        Zero, Zero), Local6)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, Zero)), Local6)), 
                        Local7)
                    Store (Local7, DMA0)
                    Store (Local7, PIO0)
                    Store (Match (DerefOf (Index (TIM0, One)), MEQ, Arg3, MTR, 
                        Zero, Zero), Local6)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, Zero)), Local6)), 
                        Local7)
                    Store (Local7, DMA1)
                    Store (Local7, PIO1)
                    If (Arg1)
                    {
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x05)), Arg2)), 
                            Local5)
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x04)), Local5)), 
                            DMA0)
                        Or (CHNF, One, CHNF)
                    }

                    If (Arg4)
                    {
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x05)), Arg5)), 
                            Local5)
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x04)), Local5)), 
                            DMA1)
                        Or (CHNF, 0x04, CHNF)
                    }

                    Return (TMD0)
                }

                Method (STM, 0, Serialized)
                {
                    If (REGF) {}
                    Else
                    {
                        Return (TMD0)
                    }

                    Store (Zero, GMUE)
                    Store (Zero, GSUE)
                    Store (0x07, GMUT)
                    Store (0x07, GSUT)
                    If (And (CHNF, One))
                    {
                        Store (Match (DerefOf (Index (TIM0, 0x04)), MLE, DMA0, MTR, 
                            Zero, Zero), Local0)
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x06)), Local0)), 
                            GMUT)
                        Or (GMUE, 0x07, GMUE)
                    }
                    Else
                    {
                        If (Or (LEqual (PIO0, Ones), LEqual (PIO0, Zero)))
                        {
                            If (And (LLess (DMA0, Ones), LGreater (DMA0, Zero)))
                            {
                                Store (DMA0, PIO0)
                            }
                        }
                    }

                    If (And (CHNF, 0x04))
                    {
                        Store (Match (DerefOf (Index (TIM0, 0x04)), MLE, DMA1, MTR, 
                            Zero, Zero), Local0)
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x06)), Local0)), 
                            GSUT)
                        Or (GSUE, 0x07, GSUE)
                    }
                    Else
                    {
                        If (Or (LEqual (PIO1, Ones), LEqual (PIO1, Zero)))
                        {
                            If (And (LLess (DMA1, Ones), LGreater (DMA1, Zero)))
                            {
                                Store (DMA1, PIO1)
                            }
                        }
                    }

                    And (Match (DerefOf (Index (TIM0, Zero)), MGE, PIO0, MTR, 
                        Zero, Zero), 0x03, Local0)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, One)), Local0)), 
                        Local1)
                    Store (Local1, GMPT)
                    And (Match (DerefOf (Index (TIM0, Zero)), MGE, PIO1, MTR, 
                        Zero, Zero), 0x03, Local0)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, One)), Local0)), 
                        Local1)
                    Store (Local1, GSPT)
                    Return (Zero)
                }
            }

            Device (USB1)
            {
                Name (_ADR, 0x00100000)
                Name (_PRW, Package (0x02)
                {
                    0x0E, 
                    0x03
                })
                Method (_S3D, 0, NotSerialized)
                {
                    If (LEqual (OSFL, 0x02))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }

                OperationRegion (U2F0, PCI_Config, Zero, 0xC2)
                Field (U2F0, ByteAcc, NoLock, Preserve)
                {
                    VID,    16, 
                            Offset (0x04), 
                    CMDR,   3, 
                            Offset (0x3C), 
                    U3IR,   4, 
                            Offset (0x84), 
                    ECDX,   2
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        If (LEqual (CMDR, Zero))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }
                }
            }

            Device (USB2)
            {
                Name (_ADR, 0x00100001)
                Name (_PRW, Package (0x02)
                {
                    0x0E, 
                    0x03
                })
                Method (_S3D, 0, NotSerialized)
                {
                    If (LEqual (OSFL, 0x02))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }

                OperationRegion (U2F1, PCI_Config, Zero, 0xC2)
                Field (U2F1, ByteAcc, NoLock, Preserve)
                {
                    VID,    16, 
                            Offset (0x04), 
                    CMDR,   3, 
                            Offset (0x3C), 
                    U4IR,   4, 
                            Offset (0x84), 
                    ECDX,   2
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        If (LEqual (CMDR, Zero))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }
                }
            }

            Device (USB3)
            {
                Name (_ADR, 0x00100002)
                Name (_PRW, Package (0x02)
                {
                    0x0E, 
                    0x03
                })
                Method (_S3D, 0, NotSerialized)
                {
                    If (LEqual (OSFL, 0x02))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }

                OperationRegion (U2F2, PCI_Config, Zero, 0xC2)
                Field (U2F2, ByteAcc, NoLock, Preserve)
                {
                    VID,    16, 
                            Offset (0x04), 
                    CMDR,   3, 
                            Offset (0x3C), 
                    U5IR,   4, 
                            Offset (0x84), 
                    ECDX,   2
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        If (LEqual (CMDR, Zero))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }
                }
            }

            Device (USB4)
            {
                Name (_ADR, 0x00100003)
                Name (_PRW, Package (0x02)
                {
                    0x0E, 
                    0x03
                })
                Method (_S3D, 0, NotSerialized)
                {
                    If (LEqual (OSFL, 0x02))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }

                OperationRegion (U2F3, PCI_Config, Zero, 0xC2)
                Field (U2F3, ByteAcc, NoLock, Preserve)
                {
                    VID,    16, 
                            Offset (0x04), 
                    CMDR,   3, 
                            Offset (0x3C), 
                    U6IR,   4, 
                            Offset (0x84), 
                    ECDX,   2
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        If (LEqual (CMDR, Zero))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }
                }
            }

            Device (EHCI)
            {
                Name (_ADR, 0x00100004)
                Name (_PRW, Package (0x02)
                {
                    0x0E, 
                    0x03
                })
                Method (_S3D, 0, NotSerialized)
                {
                    If (LEqual (OSFL, 0x02))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }

                OperationRegion (U2F4, PCI_Config, Zero, 0xC2)
                Field (U2F4, ByteAcc, NoLock, Preserve)
                {
                    VID,    16, 
                            Offset (0x04), 
                    CMDR,   3, 
                            Offset (0x3C), 
                    U7IR,   4, 
                            Offset (0x84), 
                    ECDX,   2
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        If (LEqual (CMDR, Zero))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }
                }
            }

            Device (LAN1)
            {
                Name (_ADR, 0x00120000)
                Name (_PRW, Package (0x02)
                {
                    0x03, 
                    0x05
                })
            }

            Device (APEX)
            {
                Name (_ADR, 0x05)
                OperationRegion (PESC, PCI_Config, Zero, 0x0100)
                Field (PESC, ByteAcc, NoLock, Preserve)
                {
                            Offset (0xA0), 
                        ,   5, 
                    PEHP,   1, 
                    PEPM,   1
                }

                Method (_STA, 0, NotSerialized)
                {
                    Return (0x0B)
                }
            }

            Device (BRCH)
            {
                Name (_HID, EisaId ("PNP0C02"))
                Name (_UID, 0x55)
                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUF0, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadWrite,
                            0xF0001000,         // Address Base
                            0x00001000,         // Address Length
                            )
                    })
                    Return (BUF0)
                }
            }

            Device (BRCV)
            {
                Name (_HID, EisaId ("PNP0C02"))
                Name (_UID, 0x66)
                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUF0, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadWrite,
                            0xF0002000,         // Address Base
                            0x00001000,         // Address Length
                            )
                    })
                    Return (BUF0)
                }
            }

            Device (PEXG)
            {
                Name (_ADR, 0x00020000)
                OperationRegion (RPXG, PCI_Config, Zero, 0x0100)
                Field (RPXG, ByteAcc, NoLock, Preserve)
                {
                    VID,    16, 
                            Offset (0x04), 
                    CMDR,   3, 
                            Offset (0x19), 
                    BUS2,   8
                }

                Method (_BBN, 0, NotSerialized)
                {
                    Return (BUS2)
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        If (LEqual (CMDR, Zero))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }
                }

                Name (UIDB, Buffer (0x10) {})
                CreateDWordField (UIDB, Zero, UID0)
                CreateDWordField (UIDB, 0x04, UID1)
                CreateDWordField (UIDB, 0x08, UID2)
                CreateDWordField (UIDB, 0x0C, UID3)
                Name (OSCB, Buffer (0x0C) {})
                CreateDWordField (OSCB, Zero, CAP0)
                CreateDWordField (OSCB, 0x04, CAP1)
                CreateDWordField (OSCB, 0x08, CAP2)
                Name (CHKU, Zero)
                Name (PNHP, Zero)
                Name (PNPM, Zero)
                Method (_OSC, 4, NotSerialized)
                {
                    Store (Arg0, UIDB)
                    If (LNotEqual (UID0, 0x33DB4D5B))
                    {
                        Store (One, CHKU)
                    }

                    If (LNotEqual (UID1, 0x401C1FF7))
                    {
                        Store (One, CHKU)
                    }

                    If (LNotEqual (UID2, 0x41745796))
                    {
                        Store (One, CHKU)
                    }

                    If (LNotEqual (UID3, 0x66D73DC0))
                    {
                        Store (One, CHKU)
                    }

                    Store (Arg3, OSCB)
                    If (LEqual (CHKU, Zero))
                    {
                        And (CAP2, One, PNHP)
                        And (CAP2, 0x04, PNPM)
                        If (LNotEqual (PNHP, Zero))
                        {
                            Store (Zero, ^^APEX.PEHP)
                            Store (Zero, ^^VT86.SBHP)
                            Store (Zero, G89E)
                            Store (One, HPFL)
                        }
                        Else
                        {
                            Store (One, ^^APEX.PEHP)
                            Store (One, ^^VT86.SBHP)
                            Store (One, G89E)
                            Store (Zero, HPFL)
                        }

                        If (LNotEqual (PNPM, Zero))
                        {
                            Store (Zero, ^^APEX.PEPM)
                            Store (Zero, ^^VT86.SBPM)
                            Store (Zero, G89E)
                            Store (One, PMFL)
                        }
                        Else
                        {
                            Store (One, ^^APEX.PEPM)
                            Store (One, ^^VT86.SBPM)
                            Store (One, G89E)
                            Store (Zero, PMFL)
                        }

                        And (CAP1, 0xFFFFFFFD, CAP1)
                        And (CAP2, 0xFFFFFFFD, CAP2)
                        And (CAP0, Zero, CAP0)
                        Return (OSCB)
                    }
                    Else
                    {
                        And (CAP1, 0xFFFFFFFD, CAP1)
                        Or (CAP0, 0x04, CAP0)
                        Return (OSCB)
                    }
                }

                Method (_PRW, 0, NotSerialized)
                {
                    Return (Package (0x02)
                    {
                        0x12, 
                        0x05
                    })
                }

                Name (PIC0, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        Zero, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        One, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        LNK1, 
                        Zero
                    }
                })
                Name (API0, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        Zero, 
                        Zero, 
                        0x18
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        One, 
                        Zero, 
                        0x19
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        Zero, 
                        0x1A
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        Zero, 
                        0x1B
                    }
                })
                Method (_PRT, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (PIC0)
                    }
                    Else
                    {
                        Return (API0)
                    }
                }

                Device (S0F0)
                {
                    Name (_ADR, Zero)
                    Name (_SUN, Zero)
                }

                Device (S0F1)
                {
                    Name (_ADR, One)
                    Name (_SUN, Zero)
                }

                Device (S0F2)
                {
                    Name (_ADR, 0x02)
                    Name (_SUN, Zero)
                }

                Device (S0F3)
                {
                    Name (_ADR, 0x03)
                    Name (_SUN, Zero)
                }

                Device (S0F4)
                {
                    Name (_ADR, 0x04)
                    Name (_SUN, Zero)
                }

                Device (S0F5)
                {
                    Name (_ADR, 0x05)
                    Name (_SUN, Zero)
                }

                Device (S0F6)
                {
                    Name (_ADR, 0x06)
                    Name (_SUN, Zero)
                }

                Device (S0F7)
                {
                    Name (_ADR, 0x07)
                    Name (_SUN, Zero)
                }
            }

            Device (PEX0)
            {
                Name (_ADR, 0x00030000)
                OperationRegion (RPX0, PCI_Config, Zero, 0x0100)
                Field (RPX0, ByteAcc, NoLock, Preserve)
                {
                    VID,    16, 
                            Offset (0x04), 
                    CMDR,   3, 
                            Offset (0x19), 
                    BUS3,   8
                }

                Method (_BBN, 0, NotSerialized)
                {
                    Return (BUS3)
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        If (LEqual (CMDR, Zero))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }
                }

                Method (_PRW, 0, NotSerialized)
                {
                    Return (Package (0x02)
                    {
                        0x12, 
                        0x05
                    })
                }

                Name (PIC1, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        Zero, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        One, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        LNK1, 
                        Zero
                    }
                })
                Name (API1, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        Zero, 
                        Zero, 
                        0x1C
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        One, 
                        Zero, 
                        0x1D
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        Zero, 
                        0x1E
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        Zero, 
                        0x1F
                    }
                })
                Method (_PRT, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (PIC1)
                    }
                    Else
                    {
                        Return (API1)
                    }
                }

                Device (S1F0)
                {
                    Name (_ADR, Zero)
                    Name (_SUN, One)
                }

                Device (S1F1)
                {
                    Name (_ADR, One)
                    Name (_SUN, One)
                }

                Device (S1F2)
                {
                    Name (_ADR, 0x02)
                    Name (_SUN, One)
                }

                Device (S1F3)
                {
                    Name (_ADR, 0x03)
                    Name (_SUN, One)
                }

                Device (S1F4)
                {
                    Name (_ADR, 0x04)
                    Name (_SUN, One)
                }

                Device (S1F5)
                {
                    Name (_ADR, 0x05)
                    Name (_SUN, One)
                }

                Device (S1F6)
                {
                    Name (_ADR, 0x06)
                    Name (_SUN, One)
                }

                Device (S1F7)
                {
                    Name (_ADR, 0x07)
                    Name (_SUN, One)
                }
            }

            Device (PEX1)
            {
                Name (_ADR, 0x00030001)
                OperationRegion (RPX1, PCI_Config, Zero, 0x0100)
                Field (RPX1, ByteAcc, NoLock, Preserve)
                {
                    VID,    16, 
                            Offset (0x04), 
                    CMDR,   3
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        If (LEqual (CMDR, Zero))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }
                }

                Method (_PRW, 0, NotSerialized)
                {
                    Return (Package (0x02)
                    {
                        0x12, 
                        0x05
                    })
                }

                Name (PIC2, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        Zero, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        One, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        LNK1, 
                        Zero
                    }
                })
                Name (API2, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        Zero, 
                        Zero, 
                        0x20
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        One, 
                        Zero, 
                        0x21
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        Zero, 
                        0x22
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        Zero, 
                        0x23
                    }
                })
                Method (_PRT, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (PIC2)
                    }
                    Else
                    {
                        Return (API2)
                    }
                }

                Device (S2F0)
                {
                    Name (_ADR, Zero)
                    Name (_SUN, 0x02)
                }

                Device (S2F1)
                {
                    Name (_ADR, One)
                    Name (_SUN, 0x02)
                }

                Device (S2F2)
                {
                    Name (_ADR, 0x02)
                    Name (_SUN, 0x02)
                }

                Device (S2F3)
                {
                    Name (_ADR, 0x03)
                    Name (_SUN, 0x02)
                }

                Device (S2F4)
                {
                    Name (_ADR, 0x04)
                    Name (_SUN, 0x02)
                }

                Device (S2F5)
                {
                    Name (_ADR, 0x05)
                    Name (_SUN, 0x02)
                }

                Device (S2F6)
                {
                    Name (_ADR, 0x06)
                    Name (_SUN, 0x02)
                }

                Device (S2F7)
                {
                    Name (_ADR, 0x07)
                    Name (_SUN, 0x02)
                }
            }

            Device (PEX2)
            {
                Name (_ADR, 0x00030002)
                OperationRegion (RPX2, PCI_Config, Zero, 0x0100)
                Field (RPX2, ByteAcc, NoLock, Preserve)
                {
                    VID,    16, 
                            Offset (0x04), 
                    CMDR,   3
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        If (LEqual (CMDR, Zero))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }
                }

                Method (_PRW, 0, NotSerialized)
                {
                    Return (Package (0x02)
                    {
                        0x12, 
                        0x05
                    })
                }

                Name (PIC3, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        Zero, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        One, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        LNK1, 
                        Zero
                    }
                })
                Name (API3, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        Zero, 
                        Zero, 
                        0x24
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        One, 
                        Zero, 
                        0x25
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        Zero, 
                        0x26
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        Zero, 
                        0x27
                    }
                })
                Method (_PRT, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (PIC3)
                    }
                    Else
                    {
                        Return (API3)
                    }
                }

                Device (S3F0)
                {
                    Name (_ADR, Zero)
                    Name (_SUN, 0x03)
                }

                Device (S3F1)
                {
                    Name (_ADR, One)
                    Name (_SUN, 0x03)
                }

                Device (S3F2)
                {
                    Name (_ADR, 0x02)
                    Name (_SUN, 0x03)
                }

                Device (S3F3)
                {
                    Name (_ADR, 0x03)
                    Name (_SUN, 0x03)
                }

                Device (S3F4)
                {
                    Name (_ADR, 0x04)
                    Name (_SUN, 0x03)
                }

                Device (S3F5)
                {
                    Name (_ADR, 0x05)
                    Name (_SUN, 0x03)
                }

                Device (S3F6)
                {
                    Name (_ADR, 0x06)
                    Name (_SUN, 0x03)
                }

                Device (S3F7)
                {
                    Name (_ADR, 0x07)
                    Name (_SUN, 0x03)
                }
            }

            Device (PEX3)
            {
                Name (_ADR, 0x00030003)
                OperationRegion (RPX3, PCI_Config, Zero, 0x0100)
                Field (RPX3, ByteAcc, NoLock, Preserve)
                {
                    VID,    16, 
                            Offset (0x04), 
                    CMDR,   3
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        If (LEqual (CMDR, Zero))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }
                }

                Method (_PRW, 0, NotSerialized)
                {
                    Return (Package (0x02)
                    {
                        0x12, 
                        0x05
                    })
                }

                Name (PIC4, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        Zero, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        One, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        LNK1, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        LNK1, 
                        Zero
                    }
                })
                Name (API4, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        Zero, 
                        Zero, 
                        0x28
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        One, 
                        Zero, 
                        0x29
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        Zero, 
                        0x2A
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        Zero, 
                        0x2B
                    }
                })
                Method (_PRT, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (PIC4)
                    }
                    Else
                    {
                        Return (API4)
                    }
                }

                Device (S4F0)
                {
                    Name (_ADR, Zero)
                    Name (_SUN, 0x04)
                }

                Device (S4F1)
                {
                    Name (_ADR, One)
                    Name (_SUN, 0x04)
                }

                Device (S4F2)
                {
                    Name (_ADR, 0x02)
                    Name (_SUN, 0x04)
                }

                Device (S4F3)
                {
                    Name (_ADR, 0x03)
                    Name (_SUN, 0x04)
                }

                Device (S4F4)
                {
                    Name (_ADR, 0x04)
                    Name (_SUN, 0x04)
                }

                Device (S4F5)
                {
                    Name (_ADR, 0x05)
                    Name (_SUN, 0x04)
                }

                Device (S4F6)
                {
                    Name (_ADR, 0x06)
                    Name (_SUN, 0x04)
                }

                Device (S4F7)
                {
                    Name (_ADR, 0x07)
                    Name (_SUN, 0x04)
                }
            }

            Device (P2PE)
            {
                Name (_ADR, 0x00130000)
                OperationRegion (P2ER, PCI_Config, Zero, 0x0100)
                Field (P2ER, ByteAcc, NoLock, Preserve)
                {
                    VID,    16
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        Return (0x0F)
                    }
                }

                Name (PICE, Package (0x08)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        Zero, 
                        LNKD, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        One, 
                        LNKD, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        LNKD, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        LNKD, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x0001FFFF, 
                        Zero, 
                        LNKB, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x0001FFFF, 
                        One, 
                        LNKB, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x0001FFFF, 
                        0x02, 
                        LNKB, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x0001FFFF, 
                        0x03, 
                        LNKB, 
                        Zero
                    }
                })
                Name (APIE, Package (0x08)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        Zero, 
                        Zero, 
                        0x14
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        One, 
                        Zero, 
                        0x15
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        Zero, 
                        0x16
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        Zero, 
                        0x17
                    }, 

                    Package (0x04)
                    {
                        0x0001FFFF, 
                        Zero, 
                        Zero, 
                        0x11
                    }, 

                    Package (0x04)
                    {
                        0x0001FFFF, 
                        One, 
                        Zero, 
                        0x11
                    }, 

                    Package (0x04)
                    {
                        0x0001FFFF, 
                        0x02, 
                        Zero, 
                        0x11
                    }, 

                    Package (0x04)
                    {
                        0x0001FFFF, 
                        0x03, 
                        Zero, 
                        0x11
                    }
                })
                Method (_PRT, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (PICE)
                    }
                    Else
                    {
                        Return (APIE)
                    }
                }

                Device (SBRC)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x77)
                    Method (_CRS, 0, NotSerialized)
                    {
                        Name (BUF0, ResourceTemplate ()
                        {
                            Memory32Fixed (ReadWrite,
                                0xF0000000,         // Address Base
                                0x00001000,         // Address Length
                                )
                        })
                        Return (BUF0)
                    }
                }

                Device (PE5C)
                {
                    Name (_ADR, Zero)
                    OperationRegion (PE5R, PCI_Config, Zero, 0x0100)
                    Field (PE5R, ByteAcc, NoLock, Preserve)
                    {
                        VID,    16, 
                                Offset (0x04), 
                        CMDR,   3
                    }

                    Method (_STA, 0, NotSerialized)
                    {
                        If (LNotEqual (VID, 0x1106))
                        {
                            Return (Zero)
                        }
                        Else
                        {
                            If (LEqual (CMDR, Zero))
                            {
                                Return (0x0D)
                            }
                            Else
                            {
                                Return (0x0F)
                            }
                        }
                    }

                    Method (_PRW, 0, NotSerialized)
                    {
                        Return (Package (0x02)
                        {
                            0x12, 
                            0x05
                        })
                    }

                    Name (PIC5, Package (0x04)
                    {
                        Package (0x04)
                        {
                            0xFFFF, 
                            Zero, 
                            LNKA, 
                            Zero
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            One, 
                            LNKB, 
                            Zero
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x02, 
                            LNKC, 
                            Zero
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x03, 
                            LNKD, 
                            Zero
                        }
                    })
                    Name (API5, Package (0x04)
                    {
                        Package (0x04)
                        {
                            0xFFFF, 
                            Zero, 
                            Zero, 
                            0x10
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            One, 
                            Zero, 
                            0x11
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x02, 
                            Zero, 
                            0x12
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x03, 
                            Zero, 
                            0x13
                        }
                    })
                    Method (_PRT, 0, NotSerialized)
                    {
                        If (LNot (PICF))
                        {
                            Return (PIC5)
                        }
                        Else
                        {
                            Return (API5)
                        }
                    }

                    Device (S5F0)
                    {
                        Name (_ADR, Zero)
                        Name (_SUN, 0x05)
                    }

                    Device (S5F1)
                    {
                        Name (_ADR, One)
                        Name (_SUN, 0x05)
                    }

                    Device (S5F2)
                    {
                        Name (_ADR, 0x02)
                        Name (_SUN, 0x05)
                    }

                    Device (S5F3)
                    {
                        Name (_ADR, 0x03)
                        Name (_SUN, 0x05)
                    }

                    Device (S5F4)
                    {
                        Name (_ADR, 0x04)
                        Name (_SUN, 0x05)
                    }

                    Device (S5F5)
                    {
                        Name (_ADR, 0x05)
                        Name (_SUN, 0x05)
                    }

                    Device (S5F6)
                    {
                        Name (_ADR, 0x06)
                        Name (_SUN, 0x05)
                    }

                    Device (S5F7)
                    {
                        Name (_ADR, 0x07)
                        Name (_SUN, 0x05)
                    }
                }

                Device (PE6C)
                {
                    Name (_ADR, One)
                    OperationRegion (PE6R, PCI_Config, Zero, 0x0100)
                    Field (PE6R, ByteAcc, NoLock, Preserve)
                    {
                        VID,    16, 
                                Offset (0x04), 
                        CMDR,   3
                    }

                    Method (_STA, 0, NotSerialized)
                    {
                        If (LNotEqual (VID, 0x1106))
                        {
                            Return (Zero)
                        }
                        Else
                        {
                            If (LEqual (CMDR, Zero))
                            {
                                Return (0x0D)
                            }
                            Else
                            {
                                Return (0x0F)
                            }
                        }
                    }

                    Method (_PRW, 0, NotSerialized)
                    {
                        Return (Package (0x02)
                        {
                            0x12, 
                            0x05
                        })
                    }

                    Name (PIC6, Package (0x04)
                    {
                        Package (0x04)
                        {
                            0xFFFF, 
                            Zero, 
                            LNKA, 
                            Zero
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            One, 
                            LNKB, 
                            Zero
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x02, 
                            LNKC, 
                            Zero
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x03, 
                            LNKD, 
                            Zero
                        }
                    })
                    Name (API6, Package (0x04)
                    {
                        Package (0x04)
                        {
                            0xFFFF, 
                            Zero, 
                            Zero, 
                            0x10
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            One, 
                            Zero, 
                            0x11
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x02, 
                            Zero, 
                            0x12
                        }, 

                        Package (0x04)
                        {
                            0xFFFF, 
                            0x03, 
                            Zero, 
                            0x13
                        }
                    })
                    Method (_PRT, 0, NotSerialized)
                    {
                        If (LNot (PICF))
                        {
                            Return (PIC6)
                        }
                        Else
                        {
                            Return (API6)
                        }
                    }

                    Device (S6F0)
                    {
                        Name (_ADR, Zero)
                        Name (_SUN, 0x06)
                    }

                    Device (S6F1)
                    {
                        Name (_ADR, One)
                        Name (_SUN, 0x06)
                    }

                    Device (S6F2)
                    {
                        Name (_ADR, 0x02)
                        Name (_SUN, 0x06)
                    }

                    Device (S6F3)
                    {
                        Name (_ADR, 0x03)
                        Name (_SUN, 0x06)
                    }

                    Device (S6F4)
                    {
                        Name (_ADR, 0x04)
                        Name (_SUN, 0x06)
                    }

                    Device (S6F5)
                    {
                        Name (_ADR, 0x05)
                        Name (_SUN, 0x06)
                    }

                    Device (S6F6)
                    {
                        Name (_ADR, 0x06)
                        Name (_SUN, 0x06)
                    }

                    Device (S6F7)
                    {
                        Name (_ADR, 0x07)
                        Name (_SUN, 0x06)
                    }
                }

                Device (AZAC)
                {
                    Name (_ADR, 0x00010000)
                    OperationRegion (AZAR, PCI_Config, Zero, 0x0100)
                    Field (AZAR, ByteAcc, NoLock, Preserve)
                    {
                        VID,    16, 
                                Offset (0x04), 
                        CMDR,   3
                    }

                    Method (_STA, 0, NotSerialized)
                    {
                        If (LNotEqual (VID, 0x1106))
                        {
                            Return (Zero)
                        }
                        Else
                        {
                            If (LEqual (CMDR, Zero))
                            {
                                Return (0x0D)
                            }
                            Else
                            {
                                Return (0x0F)
                            }
                        }
                    }

                    Method (_PRW, 0, NotSerialized)
                    {
                        Return (Package (0x02)
                        {
                            0x0D, 
                            0x05
                        })
                    }
                }
            }

            Device (P2PB)
            {
                Name (_ADR, 0x00130001)
                OperationRegion (P2PR, PCI_Config, Zero, 0x0100)
                Field (P2PR, ByteAcc, NoLock, Preserve)
                {
                    VID,    16
                }

                Method (_STA, 0, NotSerialized)
                {
                    If (LNotEqual (VID, 0x1106))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        Return (0x0F)
                    }
                }

                Name (_PRW, Package (0x02)
                {
                    0x05, 
                    0x05
                })
                Name (PICM, Package (0x14)
                {
                    Package (0x04)
                    {
                        0x0009FFFF, 
                        Zero, 
                        LNKA, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x0009FFFF, 
                        One, 
                        LNKB, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x0009FFFF, 
                        0x02, 
                        LNKC, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x0009FFFF, 
                        0x03, 
                        LNKD, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000AFFFF, 
                        Zero, 
                        LNKB, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000AFFFF, 
                        One, 
                        LNKC, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000AFFFF, 
                        0x02, 
                        LNKD, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000AFFFF, 
                        0x03, 
                        LNKA, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000BFFFF, 
                        Zero, 
                        LNKC, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000BFFFF, 
                        One, 
                        LNKD, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000BFFFF, 
                        0x02, 
                        LNKA, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000BFFFF, 
                        0x03, 
                        LNKB, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000DFFFF, 
                        Zero, 
                        LNKA, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000DFFFF, 
                        One, 
                        LNKB, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000DFFFF, 
                        0x02, 
                        LNKC, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000DFFFF, 
                        0x03, 
                        LNKD, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000CFFFF, 
                        Zero, 
                        LNKD, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000CFFFF, 
                        One, 
                        LNKA, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000CFFFF, 
                        0x02, 
                        LNKB, 
                        Zero
                    }, 

                    Package (0x04)
                    {
                        0x000CFFFF, 
                        0x03, 
                        LNKC, 
                        Zero
                    }
                })
                Name (APIC, Package (0x14)
                {
                    Package (0x04)
                    {
                        0x0009FFFF, 
                        Zero, 
                        Zero, 
                        0x10
                    }, 

                    Package (0x04)
                    {
                        0x0009FFFF, 
                        One, 
                        Zero, 
                        0x11
                    }, 

                    Package (0x04)
                    {
                        0x0009FFFF, 
                        0x02, 
                        Zero, 
                        0x12
                    }, 

                    Package (0x04)
                    {
                        0x0009FFFF, 
                        0x03, 
                        Zero, 
                        0x13
                    }, 

                    Package (0x04)
                    {
                        0x000AFFFF, 
                        Zero, 
                        Zero, 
                        0x11
                    }, 

                    Package (0x04)
                    {
                        0x000AFFFF, 
                        One, 
                        Zero, 
                        0x12
                    }, 

                    Package (0x04)
                    {
                        0x000AFFFF, 
                        0x02, 
                        Zero, 
                        0x13
                    }, 

                    Package (0x04)
                    {
                        0x000AFFFF, 
                        0x03, 
                        Zero, 
                        0x10
                    }, 

                    Package (0x04)
                    {
                        0x000BFFFF, 
                        Zero, 
                        Zero, 
                        0x12
                    }, 

                    Package (0x04)
                    {
                        0x000BFFFF, 
                        One, 
                        Zero, 
                        0x13
                    }, 

                    Package (0x04)
                    {
                        0x000BFFFF, 
                        0x02, 
                        Zero, 
                        0x10
                    }, 

                    Package (0x04)
                    {
                        0x000BFFFF, 
                        0x03, 
                        Zero, 
                        0x11
                    }, 

                    Package (0x04)
                    {
                        0x000DFFFF, 
                        Zero, 
                        Zero, 
                        0x10
                    }, 

                    Package (0x04)
                    {
                        0x000DFFFF, 
                        One, 
                        Zero, 
                        0x11
                    }, 

                    Package (0x04)
                    {
                        0x000DFFFF, 
                        0x02, 
                        Zero, 
                        0x12
                    }, 

                    Package (0x04)
                    {
                        0x000DFFFF, 
                        0x03, 
                        Zero, 
                        0x13
                    }, 

                    Package (0x04)
                    {
                        0x000CFFFF, 
                        Zero, 
                        Zero, 
                        0x13
                    }, 

                    Package (0x04)
                    {
                        0x000CFFFF, 
                        One, 
                        Zero, 
                        0x10
                    }, 

                    Package (0x04)
                    {
                        0x000CFFFF, 
                        0x02, 
                        Zero, 
                        0x11
                    }, 

                    Package (0x04)
                    {
                        0x000CFFFF, 
                        0x03, 
                        Zero, 
                        0x12
                    }
                })
                Method (_PRT, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (PICM)
                    }
                    Else
                    {
                        Return (APIC)
                    }
                }
            }

            Device (LNKA)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, One)
                Method (_STA, 0, NotSerialized)
                {
                    And (PIRA, 0xF0, Local0)
                    If (LEqual (Local0, Zero))
                    {
                        Return (0x09)
                    }
                    Else
                    {
                        Return (0x0B)
                    }
                }

                Method (_PRS, 0, NotSerialized)
                {
                    Name (BUFB, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {3,4,6,7,10,11,12}
                    })
                    Return (BUFB)
                }

                Method (_DIS, 0, NotSerialized)
                {
                    And (PIRA, 0x0F, PIRA)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUFB, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {}
                    })
                    CreateByteField (BUFB, One, IRB1)
                    CreateByteField (BUFB, 0x02, IRB2)
                    Store (Zero, Local3)
                    Store (Zero, Local4)
                    And (PIRA, 0xF0, Local1)
                    ShiftRight (Local1, 0x04, Local1)
                    If (LNotEqual (Local1, Zero))
                    {
                        If (LGreater (Local1, 0x07))
                        {
                            Subtract (Local1, 0x08, Local2)
                            ShiftLeft (One, Local2, Local4)
                        }
                        Else
                        {
                            If (LGreater (Local1, Zero))
                            {
                                ShiftLeft (One, Local1, Local3)
                            }
                        }

                        Store (Local3, IRB1)
                        Store (Local4, IRB2)
                    }

                    Return (BUFB)
                }

                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, One, IRB1)
                    CreateByteField (Arg0, 0x02, IRB2)
                    ShiftLeft (IRB2, 0x08, Local0)
                    Or (Local0, IRB1, Local0)
                    Store (Zero, Local1)
                    ShiftRight (Local0, One, Local0)
                    While (LGreater (Local0, Zero))
                    {
                        Increment (Local1)
                        ShiftRight (Local0, One, Local0)
                    }

                    If (LEqual (OSFL, 0x02))
                    {
                        If (ENR8)
                        {
                            Store (Local1, PIRE)
                        }
                    }

                    And (PIRA, 0x0F, PIRA)
                    ShiftLeft (Local1, 0x04, Local1)
                    Or (PIRA, Local1, PIRA)
                }
            }

            Device (LNKB)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x02)
                Method (_STA, 0, NotSerialized)
                {
                    And (PIBC, 0x0F, Local0)
                    If (LEqual (Local0, Zero))
                    {
                        Return (0x09)
                    }
                    Else
                    {
                        Return (0x0B)
                    }
                }

                Method (_PRS, 0, NotSerialized)
                {
                    Name (BUFA, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {3,4,6,7,10,11,12}
                    })
                    Return (BUFA)
                }

                Method (_DIS, 0, NotSerialized)
                {
                    And (PIBC, 0xF0, PIBC)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUFA, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {}
                    })
                    CreateByteField (BUFA, One, IRA1)
                    CreateByteField (BUFA, 0x02, IRA2)
                    Store (Zero, Local3)
                    Store (Zero, Local4)
                    And (PIBC, 0x0F, Local1)
                    If (LNotEqual (Local1, Zero))
                    {
                        If (LGreater (Local1, 0x07))
                        {
                            Subtract (Local1, 0x08, Local2)
                            ShiftLeft (One, Local2, Local4)
                        }
                        Else
                        {
                            If (LGreater (Local1, Zero))
                            {
                                ShiftLeft (One, Local1, Local3)
                            }
                        }

                        Store (Local3, IRA1)
                        Store (Local4, IRA2)
                    }

                    Return (BUFA)
                }

                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, One, IRA1)
                    CreateByteField (Arg0, 0x02, IRA2)
                    ShiftLeft (IRA2, 0x08, Local0)
                    Or (Local0, IRA1, Local0)
                    Store (Zero, Local1)
                    ShiftRight (Local0, One, Local0)
                    While (LGreater (Local0, Zero))
                    {
                        Increment (Local1)
                        ShiftRight (Local0, One, Local0)
                    }

                    If (LEqual (OSFL, 0x02))
                    {
                        If (ENR8)
                        {
                            Store (Local1, PIRF)
                        }
                    }

                    And (PIBC, 0xF0, PIBC)
                    Or (PIBC, Local1, PIBC)
                }
            }

            Device (LNKC)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x03)
                Method (_STA, 0, NotSerialized)
                {
                    And (PIBC, 0xF0, Local0)
                    If (LEqual (Local0, Zero))
                    {
                        Return (0x09)
                    }
                    Else
                    {
                        Return (0x0B)
                    }
                }

                Method (_PRS, 0, NotSerialized)
                {
                    Name (BUFC, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {3,4,6,7,10,11,12}
                    })
                    Return (BUFC)
                }

                Method (_DIS, 0, NotSerialized)
                {
                    And (PIBC, 0x0F, PIBC)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUFC, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {}
                    })
                    CreateByteField (BUFC, One, IRC1)
                    CreateByteField (BUFC, 0x02, IRC2)
                    Store (Zero, Local3)
                    Store (Zero, Local4)
                    And (PIBC, 0xF0, Local1)
                    ShiftRight (Local1, 0x04, Local1)
                    If (LNotEqual (Local1, Zero))
                    {
                        If (LGreater (Local1, 0x07))
                        {
                            Subtract (Local1, 0x08, Local2)
                            ShiftLeft (One, Local2, Local4)
                        }
                        Else
                        {
                            If (LGreater (Local1, Zero))
                            {
                                ShiftLeft (One, Local1, Local3)
                            }
                        }

                        Store (Local3, IRC1)
                        Store (Local4, IRC2)
                    }

                    Return (BUFC)
                }

                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, One, IRC1)
                    CreateByteField (Arg0, 0x02, IRC2)
                    ShiftLeft (IRC2, 0x08, Local0)
                    Or (Local0, IRC1, Local0)
                    Store (Zero, Local1)
                    ShiftRight (Local0, One, Local0)
                    While (LGreater (Local0, Zero))
                    {
                        Increment (Local1)
                        ShiftRight (Local0, One, Local0)
                    }

                    If (LEqual (OSFL, 0x02))
                    {
                        If (ENR8)
                        {
                            Store (Local1, PIRG)
                        }
                    }

                    And (PIBC, 0x0F, PIBC)
                    ShiftLeft (Local1, 0x04, Local1)
                    Or (PIBC, Local1, PIBC)
                }
            }

            Device (LNKD)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x04)
                Method (_STA, 0, NotSerialized)
                {
                    And (PIRD, 0xF0, Local0)
                    If (LEqual (Local0, Zero))
                    {
                        Return (0x09)
                    }
                    Else
                    {
                        Return (0x0B)
                    }
                }

                Method (_PRS, 0, NotSerialized)
                {
                    Name (BUFD, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {3,4,6,7,10,11,12}
                    })
                    Return (BUFD)
                }

                Method (_DIS, 0, NotSerialized)
                {
                    And (PIRD, 0x0F, PIRD)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUFD, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {}
                    })
                    CreateByteField (BUFD, One, IRD1)
                    CreateByteField (BUFD, 0x02, IRD2)
                    Store (Zero, Local3)
                    Store (Zero, Local4)
                    And (PIRD, 0xF0, Local1)
                    ShiftRight (Local1, 0x04, Local1)
                    If (LNotEqual (Local1, Zero))
                    {
                        If (LGreater (Local1, 0x07))
                        {
                            Subtract (Local1, 0x08, Local2)
                            ShiftLeft (One, Local2, Local4)
                        }
                        Else
                        {
                            If (LGreater (Local1, Zero))
                            {
                                ShiftLeft (One, Local1, Local3)
                            }
                        }

                        Store (Local3, IRD1)
                        Store (Local4, IRD2)
                    }

                    Return (BUFD)
                }

                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, One, IRD1)
                    CreateByteField (Arg0, 0x02, IRD2)
                    ShiftLeft (IRD2, 0x08, Local0)
                    Or (Local0, IRD1, Local0)
                    Store (Zero, Local1)
                    ShiftRight (Local0, One, Local0)
                    While (LGreater (Local0, Zero))
                    {
                        Increment (Local1)
                        ShiftRight (Local0, One, Local0)
                    }

                    If (LEqual (OSFL, 0x02))
                    {
                        If (ENR8)
                        {
                            Store (Local1, PIRH)
                        }
                    }

                    And (PIRD, 0x0F, PIRD)
                    ShiftLeft (Local1, 0x04, Local1)
                    Or (PIRD, Local1, PIRD)
                }
            }

            Device (LNKE)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x05)
                Method (_STA, 0, NotSerialized)
                {
                    If (LEqual (PIRE, Zero))
                    {
                        Return (0x09)
                    }
                    Else
                    {
                        Return (0x0B)
                    }
                }

                Method (_PRS, 0, NotSerialized)
                {
                    Name (BUFE, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {3,4,6,7,10,11,12}
                    })
                    Return (BUFE)
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (Zero, PIRE)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUFE, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {}
                    })
                    CreateByteField (BUFE, One, IRE1)
                    CreateByteField (BUFE, 0x02, IRE2)
                    Store (Zero, IRE1)
                    Store (Zero, IRE2)
                    Store (PIRE, Local0)
                    If (LGreater (Local0, Zero))
                    {
                        If (LGreater (Local0, 0x07))
                        {
                            Subtract (Local0, 0x08, Local1)
                            ShiftLeft (One, Local1, IRE2)
                        }
                        Else
                        {
                            Store (Local0, Local1)
                            ShiftLeft (One, Local1, IRE1)
                        }
                    }

                    Return (BUFE)
                }

                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, One, IRE1)
                    CreateByteField (Arg0, 0x02, IRE2)
                    If (LGreater (IRE2, Zero))
                    {
                        FindSetLeftBit (IRE2, Local0)
                        Decrement (Local0)
                        Add (Local0, 0x08, Local0)
                    }
                    Else
                    {
                        FindSetLeftBit (IRE1, Local0)
                        Decrement (Local0)
                    }

                    Store (One, ENR8)
                    Store (Zero, POLE)
                    Store (Local0, PIRE)
                }
            }

            Device (LNKF)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x06)
                Method (_STA, 0, NotSerialized)
                {
                    If (LEqual (PIRF, Zero))
                    {
                        Return (0x09)
                    }
                    Else
                    {
                        Return (0x0B)
                    }
                }

                Method (_PRS, 0, NotSerialized)
                {
                    Name (BUFF, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {3,4,6,7,10,11,12}
                    })
                    Return (BUFF)
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (Zero, PIRF)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUFF, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {}
                    })
                    CreateByteField (BUFF, One, IRF1)
                    CreateByteField (BUFF, 0x02, IRF2)
                    Store (Zero, IRF1)
                    Store (Zero, IRF2)
                    Store (PIRF, Local0)
                    If (LGreater (Local0, Zero))
                    {
                        If (LGreater (Local0, 0x07))
                        {
                            Subtract (Local0, 0x08, Local1)
                            ShiftLeft (One, Local0, IRF2)
                        }
                        Else
                        {
                            Store (Local0, Local1)
                            ShiftLeft (One, Local1, IRF1)
                        }
                    }

                    Return (BUFF)
                }

                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, One, IRF1)
                    CreateByteField (Arg0, 0x02, IRF2)
                    If (LGreater (IRF2, Zero))
                    {
                        FindSetLeftBit (IRF2, Local0)
                        Decrement (Local0)
                        Add (Local0, 0x08, Local0)
                    }
                    Else
                    {
                        FindSetLeftBit (IRF1, Local0)
                        Decrement (Local0)
                    }

                    Store (One, ENR8)
                    Store (Zero, POLF)
                    Store (Local0, PIRF)
                }
            }

            Device (LNK0)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x07)
                Method (_STA, 0, NotSerialized)
                {
                    If (LEqual (PIRG, Zero))
                    {
                        Return (0x09)
                    }
                    Else
                    {
                        Return (0x0B)
                    }
                }

                Method (_PRS, 0, NotSerialized)
                {
                    Name (BUFG, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {3,4,6,7,10,11,12}
                    })
                    Return (BUFG)
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (Zero, PIRG)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUFG, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {}
                    })
                    CreateByteField (BUFG, One, IRG1)
                    CreateByteField (BUFG, 0x02, IRG2)
                    Store (Zero, IRG1)
                    Store (Zero, IRG2)
                    Store (PIRG, Local0)
                    If (LGreater (Local0, Zero))
                    {
                        If (LGreater (Local0, 0x07))
                        {
                            Subtract (Local0, 0x08, Local0)
                            ShiftLeft (One, Local0, IRG2)
                        }
                        Else
                        {
                            Store (One, Local1)
                            ShiftLeft (Local1, Local0, IRG1)
                        }
                    }

                    Return (BUFG)
                }

                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, One, IRG1)
                    CreateByteField (Arg0, 0x02, IRG2)
                    If (LGreater (IRG2, Zero))
                    {
                        FindSetLeftBit (IRG2, Local0)
                        Decrement (Local0)
                        Add (Local0, 0x08, Local0)
                    }
                    Else
                    {
                        FindSetLeftBit (IRG1, Local0)
                        Decrement (Local0)
                    }

                    Store (One, ENR8)
                    Store (Zero, POLG)
                    Store (Local0, PIRG)
                }
            }

            Device (LNK1)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x08)
                Method (_STA, 0, NotSerialized)
                {
                    If (LEqual (PIRH, Zero))
                    {
                        Return (0x09)
                    }
                    Else
                    {
                        Return (0x0B)
                    }
                }

                Method (_PRS, 0, NotSerialized)
                {
                    Name (BUFH, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {3,4,6,7,10,11,12}
                    })
                    Return (BUFH)
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (Zero, PIRH)
                    If (LEqual (^^NBF4.REBD, One))
                    {
                        Store (Zero, POLH)
                    }

                    If (LEqual (^^NBF4.REBD, 0x80))
                    {
                        Store (Zero, POLH)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUFH, ResourceTemplate ()
                    {
                        IRQ (Level, ActiveLow, Shared, )
                            {}
                    })
                    CreateByteField (BUFH, One, IRH1)
                    CreateByteField (BUFH, 0x02, IRH2)
                    Store (Zero, IRH1)
                    Store (Zero, IRH2)
                    Store (PIRH, Local0)
                    If (LGreater (Local0, Zero))
                    {
                        If (LGreater (Local0, 0x07))
                        {
                            Subtract (Local0, 0x08, Local0)
                            ShiftLeft (One, Local0, IRH2)
                        }
                        Else
                        {
                            Store (One, Local1)
                            ShiftLeft (Local1, Local0, IRH1)
                        }
                    }

                    Return (BUFH)
                }

                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, One, IRH1)
                    CreateByteField (Arg0, 0x02, IRH2)
                    If (LGreater (IRH2, Zero))
                    {
                        FindSetLeftBit (IRH2, Local0)
                        Decrement (Local0)
                        Add (Local0, 0x08, Local0)
                    }
                    Else
                    {
                        FindSetLeftBit (IRH1, Local0)
                        Decrement (Local0)
                    }

                    Store (One, ENR8)
                    Store (Zero, POLH)
                    If (LEqual (^^NBF4.REBD, One))
                    {
                        Store (One, POLH)
                    }

                    If (LEqual (^^NBF4.REBD, 0x80))
                    {
                        Store (One, POLH)
                    }

                    Store (Local0, PIRH)
                }
            }

            Scope (\)
            {
                OperationRegion (SCPP, SystemIO, 0x042F, One)
                Field (SCPP, ByteAcc, NoLock, Preserve)
                {
                    SMIP,   8
                }
            }

            Method (_INI, 0, NotSerialized)
            {
                If (STRC (_OS, "Microsoft Windows"))
                {
                    Store (0x56, SMIP)
                }
                Else
                {
                    If (STRC (_OS, "Microsoft Windows NT"))
                    {
                        If (CondRefOf (\_OSI, Local0))
                        {
                            If (_OSI ("Windows 2001"))
                            {
                                Store (0x59, SMIP)
                                Store (Zero, OSFL)
                                Store (0x03, OSFX)
                            }

                            If (_OSI ("Windows 2006"))
                            {
                                Store (0x59, SMIP)
                                Store (Zero, OSFL)
                                Store (0x04, OSFX)
                            }
                        }
                        Else
                        {
                            Store (0x58, SMIP)
                            Store (Zero, OSFX)
                            Store (Zero, OSFL)
                        }
                    }
                    Else
                    {
                        Store (0x57, SMIP)
                        Store (0x02, OSFX)
                        Store (0x02, OSFL)
                    }
                }

                Store (Zero, SBFL)
                If (LEqual (DEID, 0x3147))
                {
                    Store (One, SBFL)
                }

                If (LEqual (DEID, 0x3177))
                {
                    Store (0x02, SBFL)
                }

                If (LEqual (DEID, 0x3227))
                {
                    Store (0x03, SBFL)
                }

                If (LEqual (DEID, 0x3287))
                {
                    Store (0x04, SBFL)
                }

                Store (Zero, ATFL)
                If (LEqual (BSAT, One))
                {
                    Store (0x02, ATFL)
                }
                Else
                {
                    If (LEqual (EIDE, One))
                    {
                        Store (0x02, ATFL)
                    }
                    Else
                    {
                        If (LNotEqual (^PATA.VID, 0x1106))
                        {
                            Store (One, ATFL)
                        }
                    }
                }
            }

            Scope (\)
            {
                Method (OSTP, 0, NotSerialized)
                {
                    If (LEqual (OSFX, One))
                    {
                        Store (0x56, SMIP)
                    }

                    If (LEqual (OSFX, 0x02))
                    {
                        Store (0x57, SMIP)
                    }

                    If (LEqual (OSFX, Zero))
                    {
                        Store (0x58, SMIP)
                    }

                    If (LEqual (OSFX, 0x03))
                    {
                        Store (0x59, SMIP)
                    }

                    If (LEqual (OSFX, 0x04))
                    {
                        Store (0x59, SMIP)
                    }
                }
            }

            Device (SYSR)
            {
                Name (_HID, EisaId ("PNP0C02"))
                Name (_UID, One)
                Name (_CRS, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0010,             // Range Minimum
                        0x0010,             // Range Maximum
                        0x01,               // Alignment
                        0x10,               // Length
                        )
                    IO (Decode16,
                        0x0022,             // Range Minimum
                        0x0022,             // Range Maximum
                        0x01,               // Alignment
                        0x1E,               // Length
                        )
                    IO (Decode16,
                        0x0044,             // Range Minimum
                        0x0044,             // Range Maximum
                        0x01,               // Alignment
                        0x1C,               // Length
                        )
                    IO (Decode16,
                        0x0062,             // Range Minimum
                        0x0062,             // Range Maximum
                        0x01,               // Alignment
                        0x02,               // Length
                        )
                    IO (Decode16,
                        0x0065,             // Range Minimum
                        0x0065,             // Range Maximum
                        0x01,               // Alignment
                        0x0B,               // Length
                        )
                    IO (Decode16,
                        0x0074,             // Range Minimum
                        0x0074,             // Range Maximum
                        0x01,               // Alignment
                        0x0C,               // Length
                        )
                    IO (Decode16,
                        0x0091,             // Range Minimum
                        0x0091,             // Range Maximum
                        0x01,               // Alignment
                        0x03,               // Length
                        )
                    IO (Decode16,
                        0x00A2,             // Range Minimum
                        0x00A2,             // Range Maximum
                        0x01,               // Alignment
                        0x1E,               // Length
                        )
                    IO (Decode16,
                        0x00E0,             // Range Minimum
                        0x00E0,             // Range Maximum
                        0x01,               // Alignment
                        0x10,               // Length
                        )
                    IO (Decode16,
                        0x04D0,             // Range Minimum
                        0x04D0,             // Range Maximum
                        0x01,               // Alignment
                        0x02,               // Length
                        )
                    IO (Decode16,
                        0x0290,             // Range Minimum
                        0x0290,             // Range Maximum
                        0x01,               // Alignment
                        0x08,               // Length
                        )
                    IO (Decode16,
                        0x0880,             // Range Minimum
                        0x0880,             // Range Maximum
                        0x01,               // Alignment
                        0x10,               // Length
                        )
                })
            }

            Device (PIC)
            {
                Name (_HID, EisaId ("PNP0000"))
                Name (_CRS, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0020,             // Range Minimum
                        0x0020,             // Range Maximum
                        0x01,               // Alignment
                        0x02,               // Length
                        )
                    IO (Decode16,
                        0x00A0,             // Range Minimum
                        0x00A0,             // Range Maximum
                        0x01,               // Alignment
                        0x02,               // Length
                        )
                })
            }

            Device (DMA1)
            {
                Name (_HID, EisaId ("PNP0200"))
                Name (_CRS, ResourceTemplate ()
                {
                    DMA (Compatibility, BusMaster, Transfer8, )
                        {4}
                    IO (Decode16,
                        0x0000,             // Range Minimum
                        0x0000,             // Range Maximum
                        0x01,               // Alignment
                        0x10,               // Length
                        )
                    IO (Decode16,
                        0x0080,             // Range Minimum
                        0x0080,             // Range Maximum
                        0x01,               // Alignment
                        0x11,               // Length
                        )
                    IO (Decode16,
                        0x0094,             // Range Minimum
                        0x0094,             // Range Maximum
                        0x01,               // Alignment
                        0x0C,               // Length
                        )
                    IO (Decode16,
                        0x00C0,             // Range Minimum
                        0x00C0,             // Range Maximum
                        0x01,               // Alignment
                        0x20,               // Length
                        )
                })
            }

            Device (TMR)
            {
                Name (_HID, EisaId ("PNP0100"))
                Name (_CRS, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0040,             // Range Minimum
                        0x0040,             // Range Maximum
                        0x01,               // Alignment
                        0x04,               // Length
                        )
                })
            }

            Device (HPET)
            {
                Name (_HID, EisaId ("PNP0103"))
                Name (_STA, 0x0F)
                Name (_CRS, ResourceTemplate ()
                {
                    IRQNoFlags ()
                        {0}
                    IRQNoFlags ()
                        {8}
                    Memory32Fixed (ReadOnly,
                        0xFED00000,         // Address Base
                        0x00000400,         // Address Length
                        )
                })
            }

            Device (RTC)
            {
                Name (_HID, EisaId ("PNP0B00"))
                Name (_CRS, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0070,             // Range Minimum
                        0x0070,             // Range Maximum
                        0x04,               // Alignment
                        0x02,               // Length
                        )
                })
            }

            Device (SPKR)
            {
                Name (_HID, EisaId ("PNP0800"))
                Name (_CRS, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0061,             // Range Minimum
                        0x0061,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                })
            }

            Device (COPR)
            {
                Name (_HID, EisaId ("PNP0C04"))
                Name (_CRS, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x00F0,             // Range Minimum
                        0x00F0,             // Range Maximum
                        0x01,               // Alignment
                        0x10,               // Length
                        )
                    IRQNoFlags ()
                        {13}
                })
            }

            Scope (\)
            {
                OperationRegion (WIN1, SystemIO, 0x4E, 0x02)
                Field (WIN1, ByteAcc, NoLock, Preserve)
                {
                    INDP,   8, 
                    DATA,   8
                }

                IndexField (INDP, DATA, ByteAcc, NoLock, Preserve)
                {
                            Offset (0x02), 
                    CFG,    8, 
                            Offset (0x07), 
                    LDN,    8, 
                            Offset (0x20), 
                    IDHI,   8, 
                    IDLO,   8, 
                    POWC,   8, 
                            Offset (0x30), 
                    ACTR,   8, 
                            Offset (0x60), 
                    IOAH,   8, 
                    IOAL,   8, 
                    IO2H,   8, 
                    IO2L,   8, 
                            Offset (0x70), 
                    INTR,   8, 
                            Offset (0x72), 
                    INT1,   8, 
                            Offset (0x74), 
                    DMCH,   8, 
                            Offset (0xE0), 
                    CRE0,   8, 
                    CRE1,   8, 
                    CRE2,   8, 
                    CRE3,   8, 
                    CRE4,   8, 
                            Offset (0xF0), 
                    OPT1,   8, 
                    OPT2,   8, 
                    OPT3,   8, 
                    OPT4,   8, 
                    OPT5,   8, 
                    OPT6,   8, 
                    OPT7,   8, 
                    OPT8,   8, 
                    OPT9,   8, 
                    OPTA,   8
                }

                Method (ENFG, 0, NotSerialized)
                {
                    Store (0x87, INDP)
                    Store (0x87, INDP)
                }

                Method (EXFG, 0, NotSerialized)
                {
                    Store (0xAA, INDP)
                }

                Method (EWBP, 0, NotSerialized)
                {
                    ENFG ()
                    Store (0x0A, LDN)
                    Store (Zero, OPTA)
                    Store (Zero, OPT7)
                    Store (0xFF, OPT4)
                    Store (0xFF, OPT5)
                    Store (CRE0, Local0)
                    Or (Local0, 0x63, Local0)
                    Store (Local0, CRE0)
                    Store (CRE4, Local0)
                    Or (Local0, 0x8C, Local0)
                    Store (Local0, CRE4)
                    Store (ACTR, Local0)
                    Or (Local0, One, Local0)
                    Store (Local0, ACTR)
                    EXFG ()
                }

                Method (DWBP, 0, NotSerialized)
                {
                    ENFG ()
                    Store (0x0A, LDN)
                    Store (Zero, OPTA)
                    Store (Zero, OPT7)
                    Store (Zero, OPT8)
                    Store (0xFF, OPT4)
                    Store (0xFF, OPT5)
                    Store (CRE0, Local0)
                    And (Local0, 0x9C, Local0)
                    Store (Local0, CRE0)
                    Store (CRE4, Local0)
                    And (Local0, 0x73, Local0)
                    Store (Local0, CRE4)
                    Store (ACTR, Local0)
                    And (Local0, 0xFE, Local0)
                    Store (Local0, ACTR)
                    EXFG ()
                }
            }

            OperationRegion (COM1, SystemIO, 0x03F8, 0x08)
            Field (COM1, ByteAcc, NoLock, Preserve)
            {
                P3F8,   8, 
                P3F9,   8, 
                P3FA,   8, 
                P3FB,   8, 
                P3FC,   8, 
                P3FD,   8, 
                P3FE,   8, 
                P3FF,   8
            }

            OperationRegion (COM2, SystemIO, 0x02F8, 0x08)
            Field (COM2, ByteAcc, NoLock, Preserve)
            {
                P2F8,   8, 
                P2F9,   8, 
                P2FA,   8, 
                P2FB,   8, 
                P2FC,   8, 
                P2FD,   8, 
                P2FE,   8, 
                P2FF,   8
            }

            OperationRegion (COM3, SystemIO, 0x03E8, 0x08)
            Field (COM3, ByteAcc, NoLock, Preserve)
            {
                P3E8,   8, 
                P3E9,   8, 
                P3EA,   8, 
                P3EB,   8, 
                P3EC,   8, 
                P3ED,   8, 
                P3EE,   8, 
                P3EF,   8
            }

            OperationRegion (COM4, SystemIO, 0x02E8, 0x08)
            Field (COM4, ByteAcc, NoLock, Preserve)
            {
                P2E8,   8, 
                P2E9,   8, 
                P2EA,   8, 
                P2EB,   8, 
                P2EC,   8, 
                P2ED,   8, 
                P2EE,   8, 
                P2EF,   8
            }

            Method (ICOM, 1, NotSerialized)
            {
                Store (Arg0, Local0)
                If (LEqual (Local0, 0x03F8))
                {
                    Store (P3FD, Local0)
                    Store (P3FD, Local0)
                    Store (0xC3, P3FA)
                    While (LNotEqual (P3FA, 0xC1))
                    {
                        Store (P3FE, Local0)
                    }
                }
                Else
                {
                    If (LEqual (Local0, 0x02F8))
                    {
                        Store (P2FD, Local0)
                        Store (P2FD, Local0)
                        Store (0xC3, P2FA)
                        While (LNotEqual (P2FA, 0xC1))
                        {
                            Store (P2FE, Local0)
                        }
                    }
                    Else
                    {
                        If (LEqual (Local0, 0x03E8))
                        {
                            Store (P3ED, Local0)
                            Store (P3ED, Local0)
                            Store (0xC3, P3EA)
                            While (LNotEqual (P3EA, 0xC1))
                            {
                                Store (P3EE, Local0)
                            }
                        }
                        Else
                        {
                            If (LEqual (Local0, 0x02E8))
                            {
                                Store (P2ED, Local0)
                                Store (P2ED, Local0)
                                Store (0xC3, P2EA)
                                While (LNotEqual (P2EA, 0xC1))
                                {
                                    Store (P2EE, Local0)
                                }
                            }
                        }
                    }
                }
            }

            Device (FDC0)
            {
                Name (_HID, EisaId ("PNP0700"))
                Method (_STA, 0, NotSerialized)
                {
                    ENFG ()
                    Store (Zero, LDN)
                    If (ACTR)
                    {
                        EXFG ()
                        Return (0x0F)
                    }
                    Else
                    {
                        If (LOr (IOAH, IOAL))
                        {
                            EXFG ()
                            Return (0x0D)
                        }
                        Else
                        {
                            EXFG ()
                            Return (Zero)
                        }
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    ENFG ()
                    Store (Zero, LDN)
                    Store (Zero, ACTR)
                    SLDM (DMCH, 0x04)
                    EXFG ()
                    DISD (0x03)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUF0, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x03F0,             // Range Minimum
                            0x03F0,             // Range Maximum
                            0x01,               // Alignment
                            0x06,               // Length
                            _Y01)
                        IO (Decode16,
                            0x03F7,             // Range Minimum
                            0x03F7,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {6}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {2}
                    })
                    CreateByteField (BUF0, \_SB.PCI0.FDC0._CRS._Y01._MIN, IOLO)
                    CreateByteField (BUF0, 0x03, IOHI)
                    CreateByteField (BUF0, \_SB.PCI0.FDC0._CRS._Y01._MAX, IORL)
                    CreateByteField (BUF0, 0x05, IORH)
                    ENFG ()
                    EXFG ()
                    Return (BUF0)
                }

                Name (_PRS, ResourceTemplate ()
                {
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03F0,             // Range Minimum
                            0x03F0,             // Range Maximum
                            0x01,               // Alignment
                            0x06,               // Length
                            )
                        IO (Decode16,
                            0x03F7,             // Range Minimum
                            0x03F7,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {6}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {2}
                    }
                    EndDependentFn ()
                })
                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, 0x02, IOLO)
                    CreateByteField (Arg0, 0x03, IOHI)
                    CreateWordField (Arg0, 0x02, IOAD)
                    CreateWordField (Arg0, 0x19, IRQL)
                    CreateByteField (Arg0, 0x1C, DMAV)
                    ENFG ()
                    Store (Zero, LDN)
                    Store (One, ACTR)
                    SLDM (DMCH, DMCH)
                    EXFG ()
                    CKIO (IOAD, 0x03)
                }
            }

            Device (UAR1)
            {
                Name (_HID, EisaId ("PNP0501"))
                Name (_UID, One)
                Method (_STA, 0, NotSerialized)
                {
                    ENFG ()
                    Store (0x02, LDN)
                    If (ACTR)
                    {
                        EXFG ()
                        Return (0x0F)
                    }
                    Else
                    {
                        If (LOr (IOAH, IOAL))
                        {
                            EXFG ()
                            Return (0x0D)
                        }
                        Else
                        {
                            EXFG ()
                            Return (Zero)
                        }
                    }

                    EXFG ()
                }

                Method (_DIS, 0, NotSerialized)
                {
                    ENFG ()
                    Store (0x02, LDN)
                    Store (Zero, ACTR)
                    EXFG ()
                    DISD (Zero)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUF1, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            _Y02)
                        IRQNoFlags (_Y03)
                            {}
                    })
                    CreateByteField (BUF1, \_SB.PCI0.UAR1._CRS._Y02._MIN, IOLO)
                    CreateByteField (BUF1, 0x03, IOHI)
                    CreateByteField (BUF1, \_SB.PCI0.UAR1._CRS._Y02._MAX, IORL)
                    CreateByteField (BUF1, 0x05, IORH)
                    CreateWordField (BUF1, \_SB.PCI0.UAR1._CRS._Y03._INT, IRQW)
                    ENFG ()
                    Store (0x02, LDN)
                    Store (IOAL, IOLO)
                    Store (IOAL, IORL)
                    Store (IOAH, IOHI)
                    Store (IOAH, IORH)
                    Store (One, Local0)
                    ShiftLeft (Local0, INTR, IRQW)
                    EXFG ()
                    Return (BUF1)
                }

                Name (_PRS, ResourceTemplate ()
                {
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03F8,             // Range Minimum
                            0x03F8,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x02F8,             // Range Minimum
                            0x02F8,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03E8,             // Range Minimum
                            0x03E8,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x02E8,             // Range Minimum
                            0x02E8,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    EndDependentFn ()
                })
                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, 0x02, IOLO)
                    CreateByteField (Arg0, 0x03, IOHI)
                    CreateWordField (Arg0, 0x02, IOAD)
                    CreateWordField (Arg0, 0x09, IRQW)
                    ENFG ()
                    Store (0x02, LDN)
                    Store (One, ACTR)
                    Store (IOLO, IOAL)
                    Store (IOHI, IOAH)
                    FindSetRightBit (IRQW, Local0)
                    Subtract (Local0, One, INTR)
                    EXFG ()
                    CKIO (IOAD, Zero)
                }
            }

            Device (UAR2)
            {
                Name (_HID, EisaId ("PNP0501"))
                Name (_UID, 0x02)
                Method (_STA, 0, NotSerialized)
                {
                    ENFG ()
                    Store (0x03, LDN)
                    And (OPT2, 0x30, Local0)
                    If (LNotEqual (Local0, 0x10))
                    {
                        If (ACTR)
                        {
                            EXFG ()
                            Return (0x0F)
                        }
                        Else
                        {
                            If (LOr (IOAH, IOAL))
                            {
                                EXFG ()
                                Return (0x0D)
                            }
                            Else
                            {
                                EXFG ()
                                Return (Zero)
                            }
                        }
                    }
                    Else
                    {
                        EXFG ()
                        Return (Zero)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    ENFG ()
                    Store (0x03, LDN)
                    And (OPT2, 0x38, Local0)
                    If (LEqual (Local0, Zero))
                    {
                        Store (Zero, ACTR)
                    }

                    EXFG ()
                    DISD (One)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUF2, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            _Y04)
                        IRQNoFlags (_Y05)
                            {4}
                    })
                    CreateByteField (BUF2, \_SB.PCI0.UAR2._CRS._Y04._MIN, IOLO)
                    CreateByteField (BUF2, 0x03, IOHI)
                    CreateByteField (BUF2, \_SB.PCI0.UAR2._CRS._Y04._MAX, IORL)
                    CreateByteField (BUF2, 0x05, IORH)
                    CreateWordField (BUF2, \_SB.PCI0.UAR2._CRS._Y05._INT, IRQW)
                    ENFG ()
                    Store (0x03, LDN)
                    Store (IOAL, IOLO)
                    Store (IOAL, IORL)
                    Store (IOAH, IOHI)
                    Store (IOAH, IORH)
                    Store (One, Local0)
                    ShiftLeft (Local0, INTR, IRQW)
                    EXFG ()
                    Return (BUF2)
                }

                Name (_PRS, ResourceTemplate ()
                {
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03F8,             // Range Minimum
                            0x03F8,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x02F8,             // Range Minimum
                            0x02F8,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03E8,             // Range Minimum
                            0x03E8,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x02E8,             // Range Minimum
                            0x02E8,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    EndDependentFn ()
                })
                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, 0x02, IOLO)
                    CreateByteField (Arg0, 0x03, IOHI)
                    CreateWordField (Arg0, 0x02, IOAD)
                    CreateWordField (Arg0, 0x09, IRQW)
                    ENFG ()
                    Store (0x03, LDN)
                    Store (One, ACTR)
                    Store (IOLO, IOAL)
                    Store (IOHI, IOAH)
                    FindSetRightBit (IRQW, Local0)
                    Subtract (Local0, One, INTR)
                    EXFG ()
                    CKIO (IOAD, One)
                }
            }

            Device (IRDA)
            {
                Name (_HID, EisaId ("PNP0510"))
                Method (_STA, 0, NotSerialized)
                {
                    ENFG ()
                    Store (0x03, LDN)
                    And (OPT2, 0x30, Local0)
                    If (LEqual (Local0, 0x10))
                    {
                        If (ACTR)
                        {
                            EXFG ()
                            Return (0x0F)
                        }
                        Else
                        {
                            If (LOr (IOAH, IOAL))
                            {
                                EXFG ()
                                Return (0x0D)
                            }
                            Else
                            {
                                EXFG ()
                                Return (Zero)
                            }
                        }
                    }
                    Else
                    {
                        EXFG ()
                        Return (Zero)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    If (LEqual (DISE, One))
                    {
                        ENFG ()
                        Store (0x03, LDN)
                        And (OPT2, 0x38, Local0)
                        If (LNotEqual (Local0, Zero))
                        {
                            Store (Zero, ACTR)
                        }

                        EXFG ()
                        DISD (One)
                    }

                    Store ("Local0", Local0)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUF4, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            _Y06)
                        IRQNoFlags (_Y07)
                            {}
                    })
                    CreateByteField (BUF4, \_SB.PCI0.IRDA._CRS._Y06._MIN, IOLO)
                    CreateByteField (BUF4, 0x03, IOHI)
                    CreateByteField (BUF4, \_SB.PCI0.IRDA._CRS._Y06._MAX, IORL)
                    CreateByteField (BUF4, 0x05, IORH)
                    CreateWordField (BUF4, \_SB.PCI0.IRDA._CRS._Y07._INT, IRQW)
                    ENFG ()
                    Store (0x03, LDN)
                    Store (IOAL, IOLO)
                    Store (IOAL, IORL)
                    Store (IOAH, IOHI)
                    Store (IOAH, IORH)
                    ShiftLeft (One, INTR, IRQW)
                    EXFG ()
                    Return (BUF4)
                }

                Name (_PRS, ResourceTemplate ()
                {
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03F8,             // Range Minimum
                            0x03F8,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x02F8,             // Range Minimum
                            0x02F8,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03E8,             // Range Minimum
                            0x03E8,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x02E8,             // Range Minimum
                            0x02E8,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    EndDependentFn ()
                })
                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, 0x02, IOLO)
                    CreateByteField (Arg0, 0x03, IOHI)
                    CreateWordField (Arg0, 0x02, IOAD)
                    CreateWordField (Arg0, 0x09, IRQW)
                    ENFG ()
                    Store (0x03, LDN)
                    Store (One, ACTR)
                    Store (IOLO, IOAL)
                    Store (IOHI, IOAH)
                    FindSetRightBit (IRQW, Local0)
                    Subtract (Local0, One, INTR)
                    EXFG ()
                    CKIO (IOAD, One)
                }
            }

            Device (LPT1)
            {
                Name (_HID, EisaId ("PNP0400"))
                Method (_STA, 0, NotSerialized)
                {
                    ENFG ()
                    Store (One, LDN)
                    And (OPT1, 0x02, Local0)
                    If (LNotEqual (Local0, 0x02))
                    {
                        If (ACTR)
                        {
                            EXFG ()
                            Return (0x0F)
                        }
                        Else
                        {
                            If (LOr (IOAH, IOAL))
                            {
                                EXFG ()
                                Return (0x0D)
                            }
                            Else
                            {
                                EXFG ()
                                Return (Zero)
                            }
                        }
                    }
                    Else
                    {
                        EXFG ()
                        Return (Zero)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    ENFG ()
                    Store (One, LDN)
                    Store (Zero, ACTR)
                    EXFG ()
                    DISD (0x02)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUF5, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            _Y08)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x04,               // Length
                            _Y09)
                        IRQNoFlags (_Y0A)
                            {}
                    })
                    CreateByteField (BUF5, \_SB.PCI0.LPT1._CRS._Y08._MIN, IOLO)
                    CreateByteField (BUF5, 0x03, IOHI)
                    CreateByteField (BUF5, \_SB.PCI0.LPT1._CRS._Y08._MAX, IORL)
                    CreateByteField (BUF5, 0x05, IORH)
                    CreateByteField (BUF5, \_SB.PCI0.LPT1._CRS._Y08._LEN, IOLE)
                    CreateByteField (BUF5, \_SB.PCI0.LPT1._CRS._Y09._MIN, IO21)
                    CreateByteField (BUF5, 0x0B, IO22)
                    CreateByteField (BUF5, \_SB.PCI0.LPT1._CRS._Y09._MAX, IO23)
                    CreateByteField (BUF5, 0x0D, IO24)
                    CreateWordField (BUF5, \_SB.PCI0.LPT1._CRS._Y0A._INT, IRQW)
                    ENFG ()
                    Store (One, LDN)
                    Store (IOAL, IOLO)
                    Store (IOLO, IORL)
                    Store (IOAH, IOHI)
                    Store (IOHI, IORH)
                    Store (IOAL, IO21)
                    Store (IOAL, IO23)
                    Add (IOAH, 0x04, IO22)
                    Add (IOAH, 0x04, IO24)
                    If (LEqual (IOLO, 0xBC))
                    {
                        Store (0x04, IOLE)
                    }
                    Else
                    {
                        Store (0x08, IOLE)
                    }

                    Store (One, Local0)
                    Store (INTR, Local5)
                    ShiftLeft (Local0, Local5, IRQW)
                    Store (One, ACTR)
                    EXFG ()
                    Return (BUF5)
                }

                Name (_PRS, ResourceTemplate ()
                {
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0378,             // Range Minimum
                            0x0378,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0778,             // Range Minimum
                            0x0778,             // Range Maximum
                            0x01,               // Alignment
                            0x04,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0278,             // Range Minimum
                            0x0278,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0678,             // Range Minimum
                            0x0678,             // Range Maximum
                            0x01,               // Alignment
                            0x04,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03BC,             // Range Minimum
                            0x03BC,             // Range Maximum
                            0x01,               // Alignment
                            0x04,               // Length
                            )
                        IO (Decode16,
                            0x07BC,             // Range Minimum
                            0x07BC,             // Range Maximum
                            0x01,               // Alignment
                            0x04,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                    }
                    EndDependentFn ()
                })
                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, 0x02, IOLO)
                    CreateByteField (Arg0, 0x03, IOHI)
                    CreateWordField (Arg0, 0x02, IOAD)
                    CreateByteField (Arg0, 0x04, IORL)
                    CreateByteField (Arg0, 0x05, IORH)
                    CreateWordField (Arg0, 0x11, IRQW)
                    ENFG ()
                    Store (One, LDN)
                    Store (One, ACTR)
                    Store (IOLO, IOAL)
                    Store (IOHI, IOAH)
                    FindSetLeftBit (IRQW, Local0)
                    Subtract (Local0, One, Local0)
                    Store (Local0, INTR)
                    EXFG ()
                    CKIO (IOAD, 0x02)
                }
            }

            Device (ECP1)
            {
                Name (_HID, EisaId ("PNP0401"))
                Method (_STA, 0, NotSerialized)
                {
                    ENFG ()
                    Store (One, LDN)
                    And (OPT1, 0x02, Local0)
                    If (LEqual (Local0, 0x02))
                    {
                        If (ACTR)
                        {
                            EXFG ()
                            Return (0x0F)
                        }
                        Else
                        {
                            If (LOr (IOAH, IOAL))
                            {
                                EXFG ()
                                Return (0x0D)
                            }
                            Else
                            {
                                EXFG ()
                                Return (Zero)
                            }
                        }
                    }
                    Else
                    {
                        EXFG ()
                        Return (Zero)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    ENFG ()
                    Store (One, LDN)
                    Store (Zero, ACTR)
                    SLDM (DMCH, 0x04)
                    EXFG ()
                    DISD (0x02)
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUF6, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            _Y0B)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x04,               // Length
                            _Y0C)
                        IRQNoFlags (_Y0D)
                            {}
                        DMA (Compatibility, NotBusMaster, Transfer8, _Y0E)
                            {}
                    })
                    CreateByteField (BUF6, \_SB.PCI0.ECP1._CRS._Y0B._MIN, IOLO)
                    CreateByteField (BUF6, 0x03, IOHI)
                    CreateByteField (BUF6, \_SB.PCI0.ECP1._CRS._Y0B._MAX, IORL)
                    CreateByteField (BUF6, 0x05, IORH)
                    CreateByteField (BUF6, \_SB.PCI0.ECP1._CRS._Y0C._MIN, IOEL)
                    CreateByteField (BUF6, 0x0B, IOEH)
                    CreateByteField (BUF6, \_SB.PCI0.ECP1._CRS._Y0C._MAX, IOML)
                    CreateByteField (BUF6, 0x0D, IOMH)
                    CreateByteField (BUF6, \_SB.PCI0.ECP1._CRS._Y0B._LEN, IOLE)
                    CreateWordField (BUF6, \_SB.PCI0.ECP1._CRS._Y0D._INT, IRQW)
                    CreateByteField (BUF6, \_SB.PCI0.ECP1._CRS._Y0E._DMA, DMAC)
                    ENFG ()
                    Store (One, LDN)
                    Store (One, ACTR)
                    Store (IOAL, Local2)
                    Store (Local2, IOLO)
                    Store (IOAH, Local3)
                    Store (Local3, IOHI)
                    Or (Local3, 0x04, Local3)
                    Store (Local3, IOEH)
                    Store (Local3, IOMH)
                    Store (IOLO, IORL)
                    Store (IOLO, IOEL)
                    Store (IOLO, IOML)
                    Store (IOHI, IORH)
                    If (LEqual (IOLO, 0xBC))
                    {
                        Store (0x04, IOLE)
                    }
                    Else
                    {
                        Store (0x08, IOLE)
                    }

                    Store (One, Local0)
                    Store (INTR, Local5)
                    ShiftLeft (Local0, Local5, IRQW)
                    Store (One, Local0)
                    Store (DMCH, Local5)
                    ShiftLeft (Local0, Local5, DMAC)
                    EXFG ()
                    Return (BUF6)
                }

                Name (_PRS, ResourceTemplate ()
                {
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0378,             // Range Minimum
                            0x0378,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0778,             // Range Minimum
                            0x0778,             // Range Maximum
                            0x01,               // Alignment
                            0x04,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {0,1,3}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0278,             // Range Minimum
                            0x0278,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0678,             // Range Minimum
                            0x0678,             // Range Maximum
                            0x01,               // Alignment
                            0x04,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {0,1,3}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03BC,             // Range Minimum
                            0x03BC,             // Range Maximum
                            0x01,               // Alignment
                            0x04,               // Length
                            )
                        IO (Decode16,
                            0x07BC,             // Range Minimum
                            0x07BC,             // Range Maximum
                            0x01,               // Alignment
                            0x04,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,7,9,10,11,12}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {0,1,3}
                    }
                    EndDependentFn ()
                })
                Method (_SRS, 1, NotSerialized)
                {
                    CreateByteField (Arg0, 0x02, IOLO)
                    CreateByteField (Arg0, 0x03, IOHI)
                    CreateWordField (Arg0, 0x02, IOAD)
                    CreateWordField (Arg0, 0x11, IRQW)
                    CreateByteField (Arg0, 0x14, DMAC)
                    ENFG ()
                    Store (One, LDN)
                    Store (One, ACTR)
                    Store (IOLO, IOAL)
                    Store (IOHI, IOAH)
                    FindSetLeftBit (IRQW, Local0)
                    Subtract (Local0, One, Local0)
                    Store (Local0, INTR)
                    FindSetLeftBit (DMAC, Local1)
                    Store (DMCH, Local0)
                    Subtract (Local1, One, DMCH)
                    SLDM (Local0, DMCH)
                    EXFG ()
                    CKIO (IOAD, 0x02)
                }
            }

            OperationRegion (KBCT, SystemIO, 0x60, 0x05)
            Field (KBCT, ByteAcc, NoLock, Preserve)
            {
                P060,   8, 
                        Offset (0x04), 
                P064,   8
            }

            Device (PS2M)
            {
                Name (_HID, EisaId ("PNP0F13"))
                Method (_STA, 0, NotSerialized)
                {
                    If (LEqual (PS2F, Zero))
                    {
                        Return (0x0F)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    Name (BUF1, ResourceTemplate ()
                    {
                        IRQNoFlags ()
                            {12}
                    })
                    Name (BUF2, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0060,             // Range Minimum
                            0x0060,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0064,             // Range Minimum
                            0x0064,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {12}
                    })
                    If (LEqual (KBDI, One))
                    {
                        If (LEqual (OSFL, 0x02))
                        {
                            Return (BUF1)
                        }

                        If (LEqual (OSFL, One))
                        {
                            Return (BUF1)
                        }
                        Else
                        {
                            Return (BUF2)
                        }
                    }
                    Else
                    {
                        Return (BUF1)
                    }
                }
            }

            Device (PS2K)
            {
                Name (_HID, EisaId ("PNP0303"))
                Name (_CID, EisaId ("PNP030B"))
                Method (_STA, 0, NotSerialized)
                {
                    If (LEqual (KBDI, One))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        Return (0x0F)
                    }
                }

                Name (_CRS, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0060,             // Range Minimum
                        0x0060,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                    IO (Decode16,
                        0x0064,             // Range Minimum
                        0x0064,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                    IRQNoFlags ()
                        {1}
                })
            }

            Device (PSMR)
            {
                Name (_HID, EisaId ("PNP0C02"))
                Name (_UID, 0x03)
                Method (_STA, 0, NotSerialized)
                {
                    If (LEqual (KBDI, Zero))
                    {
                        Return (Zero)
                    }

                    If (LEqual (PS2F, Zero))
                    {
                        If (LEqual (OSFL, 0x02))
                        {
                            Return (0x0F)
                        }

                        If (LEqual (OSFL, One))
                        {
                            Return (0x0F)
                        }

                        Return (Zero)
                    }

                    Return (Zero)
                }

                Name (_CRS, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0060,             // Range Minimum
                        0x0060,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                    IO (Decode16,
                        0x0064,             // Range Minimum
                        0x0064,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                })
            }

            Scope (\)
            {
                OperationRegion (COM2, SystemIO, 0x02F8, 0x08)
                Field (COM2, ByteAcc, NoLock, Preserve)
                {
                    P2F8,   8, 
                    P2F9,   8, 
                    P2FA,   8, 
                    P2FB,   8, 
                    P2FC,   8, 
                    P2FD,   8, 
                    P2FE,   8, 
                    P2FF,   8
                }

                Method (MDCS, 1, NotSerialized)
                {
                    MEC2 ()
                    Sleep (0x06)
                    If (LEqual (Arg0, Zero))
                    {
                        SCB0 ()
                    }

                    If (LEqual (Arg0, 0x03))
                    {
                        SCB3 ()
                    }

                    If (LEqual (Arg0, 0x04))
                    {
                        SCB4 ()
                    }

                    If (LEqual (Arg0, 0x05))
                    {
                        SCB4 ()
                    }

                    MDC2 ()
                }

                Method (SCB3, 0, NotSerialized)
                {
                    Store (0x1B, P2F8)
                    Sleep (0x06)
                    Store (0x50, P2F8)
                    Sleep (0x06)
                    Store (0x1B, P2F8)
                    Sleep (0x06)
                    Store (0x22, P2F8)
                    Sleep (0x06)
                    Store (0x20, P2F8)
                    Sleep (0x06)
                    Store (0x20, P2F8)
                    Sleep (0x06)
                    Store (0x20, P2F8)
                    Sleep (0x06)
                    Store (0x20, P2F8)
                    Sleep (0x06)
                    Store (0x53, P2F8)
                    Sleep (0x06)
                    Store (0x54, P2F8)
                    Sleep (0x06)
                    Store (0x41, P2F8)
                    Sleep (0x06)
                    Store (0x4E, P2F8)
                    Sleep (0x06)
                    Store (0x44, P2F8)
                    Sleep (0x06)
                    Store (0x42, P2F8)
                    Sleep (0x06)
                    Store (0x59, P2F8)
                    Sleep (0x06)
                    Store (0x1B, P2F8)
                    Sleep (0x06)
                    Store (0x21, P2F8)
                    Sleep (0x06)
                    Store (0x20, P2F8)
                    Sleep (0x06)
                    Store (0x1B, P2F8)
                    Sleep (0x06)
                    Store (0x53, P2F8)
                    Sleep (0x64)
                }

                Method (SCB0, 0, NotSerialized)
                {
                    Store (0x1F, P2F8)
                    Sleep (0x64)
                }

                Method (SCB4, 0, NotSerialized)
                {
                    Store (0x1B, P2F8)
                    Sleep (0x06)
                    Store (0x50, P2F8)
                    Sleep (0x06)
                    Store (0x1B, P2F8)
                    Sleep (0x06)
                    Store (0x05, P2F8)
                    Sleep (0x06)
                    Sleep (0x64)
                }

                Method (MEC2, 0, NotSerialized)
                {
                    Or (LPE1, 0x80, LPE1)
                    ENFG ()
                    Store (0x03, LDN)
                    Store (One, ACTR)
                    EXFG ()
                    Store (0x80, P2FB)
                    Sleep (0x06)
                    Store (Zero, P2F9)
                    Sleep (0x06)
                    Store (0x0C, P2F8)
                    Sleep (0x06)
                    Store (0x03, P2FB)
                }

                Method (MDC2, 0, NotSerialized)
                {
                    And (LPE1, 0x7F, LPE1)
                    ENFG ()
                    Store (0x03, LDN)
                    Store (Zero, ACTR)
                    EXFG ()
                }
            }

            Method (UAR1._PRW, 0, NotSerialized)
            {
                Return (Package (0x02)
                {
                    0x08, 
                    0x05
                })
            }
        }

        Device (MEM)
        {
            Name (_HID, EisaId ("PNP0C01"))
            Method (_CRS, 0, NotSerialized)
            {
                Name (BUF0, ResourceTemplate ()
                {
                    Memory32Fixed (ReadWrite,
                        0x000F0000,         // Address Base
                        0x00004000,         // Address Length
                        _Y10)
                    Memory32Fixed (ReadWrite,
                        0x000F4000,         // Address Base
                        0x00004000,         // Address Length
                        _Y11)
                    Memory32Fixed (ReadWrite,
                        0x000F8000,         // Address Base
                        0x00004000,         // Address Length
                        _Y12)
                    Memory32Fixed (ReadWrite,
                        0x000FC000,         // Address Base
                        0x00004000,         // Address Length
                        _Y13)
                    Memory32Fixed (ReadWrite,
                        0x00000000,         // Address Base
                        0x00010000,         // Address Length
                        _Y0F)
                    Memory32Fixed (ReadWrite,
                        0xFFFF0000,         // Address Base
                        0x00010000,         // Address Length
                        )
                    Memory32Fixed (ReadWrite,
                        0x00000000,         // Address Base
                        0x000A0000,         // Address Length
                        )
                    Memory32Fixed (ReadWrite,
                        0x00100000,         // Address Base
                        0x00000000,         // Address Length
                        _Y14)
                    Memory32Fixed (ReadWrite,
                        0xFEC00000,         // Address Base
                        0x00001000,         // Address Length
                        )
                    Memory32Fixed (ReadWrite,
                        0xFEE00000,         // Address Base
                        0x00001000,         // Address Length
                        )
                    Memory32Fixed (ReadWrite,
                        0xFFF80000,         // Address Base
                        0x00070000,         // Address Length
                        )
                })
                CreateDWordField (BUF0, \_SB.MEM._CRS._Y0F._BAS, ACMM)
                CreateDWordField (BUF0, \_SB.MEM._CRS._Y0F._LEN, ASSM)
                CreateDWordField (BUF0, \_SB.MEM._CRS._Y10._BAS, RMA1)
                CreateDWordField (BUF0, \_SB.MEM._CRS._Y10._LEN, RSS1)
                CreateDWordField (BUF0, \_SB.MEM._CRS._Y11._BAS, RMA2)
                CreateDWordField (BUF0, \_SB.MEM._CRS._Y11._LEN, RSS2)
                CreateDWordField (BUF0, \_SB.MEM._CRS._Y12._BAS, RMA3)
                CreateDWordField (BUF0, \_SB.MEM._CRS._Y12._LEN, RSS3)
                CreateDWordField (BUF0, \_SB.MEM._CRS._Y13._BAS, RMA4)
                CreateDWordField (BUF0, \_SB.MEM._CRS._Y13._LEN, RSS4)
                CreateDWordField (BUF0, \_SB.MEM._CRS._Y14._LEN, EXTM)
                Subtract (AMEM, 0x00100000, EXTM)
                If (LNotEqual (ROM1, Zero))
                {
                    Store (RMA1, RMA2)
                    ShiftLeft (ROM1, 0x08, Local0)
                    Store (Local0, RMA1)
                    ShiftLeft (RMS1, 0x08, Local0)
                    Store (Local0, RSS1)
                    Store (0x8000, RSS2)
                }

                If (LNotEqual (ROM2, Zero))
                {
                    Store (RMA2, RMA3)
                    ShiftLeft (ROM2, 0x08, Local0)
                    Store (Local0, RMA2)
                    ShiftLeft (RMS2, 0x08, Local0)
                    Store (Local0, RSS2)
                    Store (0xC000, RSS3)
                }

                If (LNotEqual (ROM3, Zero))
                {
                    Store (RMA3, RMA4)
                    ShiftLeft (ROM3, 0x08, Local0)
                    Store (Local0, RMA3)
                    ShiftLeft (RMS3, 0x08, Local0)
                    Store (Local0, RSS3)
                    Store (0x00010000, RSS4)
                }

                Store (AMEM, ACMM)
                And (AMEM, 0x000FFFFF, Local0)
                Subtract (0x00100000, Local0, ASSM)
                Return (BUF0)
            }
        }

        Device (PCI0.EXPL)
        {
            Name (_HID, EisaId ("PNP0C02"))
            Name (_UID, 0x04)
            Method (_CRS, 0, NotSerialized)
            {
                Name (BUF0, ResourceTemplate ()
                {
                    Memory32Fixed (ReadWrite,
                        0xE0000000,         // Address Base
                        0x10000000,         // Address Length
                        )
                })
                Return (BUF0)
            }
        }
    }
}

